class SidfmdMailer < ActionMailer::Base
  SEND_MAIL_NUM = 5 
  SEND_MAIL_TIMEOUT_SECOND = 10
  MAIL_LIMIT_DATA_NUM = 100
  MAIL_KEYWORDS = [
    "%RISK_RATE_SRI_MATCH%", "%RISK_RATE_SRI_ALL%", "%UNHANDLED_RATE_SRI_MATCH%", "%UNHANDLED_RATE_SRI_ALL%",
    "%RISK_RATE_CVSS_MATCH%", "%RISK_RATE_CVSS_ALL%", "%UNHANDLED_RATE_CVSS_MATCH%", "%UNHANDLED_RATE_CVSS_ALL%",
    "%HANDLING_RATE_MATCH%", "%HANDLING_RATE_ALL%",
    "%URL%", "%TITLE%",
    "%OS_RATE_MATCH%", "%OS_MATCH%", "%HOST_MATCH%", "%HOSTINFO_MATCH%", "%S_CATEGORY_MATCH%", "%C_CATEGORY_MATCH%", "%HOST_LINKS_MATCH%", "%DISPLAY_NAME_MATCH%",
    "%OS_RATE_ALL%", "%OS_ALL%", "%HOST_ALL%", "%HOSTINFO_ALL%", "%S_CATEGORY_ALL%", "%C_CATEGORY_ALL%", "%HOST_LINKS_ALL%", "%DISPLAY_NAME_ALL%",
    "%VULINFO_MATCH%", "%VULTITLE_MATCH%", "%VUL_LINKS_MATCH%", "%SIDfmID_MATCH%", "%SIDfm_LINKS_MATCH%", "%MS_LINKS_MATCH%",
    "%VUL_HOSTS_MATCH%", "%VUL_DISPLAY_NAME_MATCH%",
    "%VULINFO_ALL%", "%VULTITLE_ALL%", "%VUL_LINKS_ALL%", "%SIDfmID_ALL%", "%SIDfm_LINKS_ALL%", "%MS_LINKS_ALL%", "%KB_MATCH%", "%KB_ALL%",
    "%APP_MATCH%", "%PRODUCT_MATCH%", "%LPRODUCT_MATCH%", "%APP_ALL%", "%PRODUCT_ALL%", "%LPRODUCT_ALL%",
    "%RULE_NAME%", "%RULE_CATEGORY%", "%RULE_TIMING%", "%RULE_COND%", "%RULE_ACTION%", "%RULE_DATE%",
    "%VULSYNC_ALL_HOST%", "%VULSYNC_ALL_DISPLAY_NAME%",
    "%VULSYNC_INFO_REGI_ALL%", "%VULSYNC_INFO_RENEW_ALL%", "%VULSYNC_INFO_DEL_ALL%", "%VULSYNC_REGI_ALL%", "%VULSYNC_RENEW_ALL%", "%VULSYNC_DEL_ALL%",
    "%VULSYNC_REGI_HOST_ALL%", "%VULSYNC_REGI_DISPLAY_NAME_ALL%", "%VULSYNC_RENEW_HOST_ALL%", "%VULSYNC_RENEW_DISPLAY_NAME_ALL%", "%VULSYNC_DEL_HOST_ALL%", "%VULSYNC_DEL_DISPLAY_NAME_ALL%",
    "%VULSYNC_INFO_REGI_MATCH%", "%VULSYNC_INFO_RENEW_MATCH%", "%VULSYNC_INFO_DEL_MATCH%", "%VULSYNC_REGI_MATCH%", "%VULSYNC_RENEW_MATCH%", "%VULSYNC_DEL_MATCH%", 
    "%VULSYNC_REGI_HOST_MATCH%", "%VULSYNC_REGI_DISPLAY_NAME_MATCH%", "%VULSYNC_RENEW_HOST_MATCH%", "%VULSYNC_RENEW_DISPLAY_NAME_MATCH%", "%VULSYNC_DEL_HOST_MATCH%", "%VULSYNC_DEL_DISPLAY_NAME_MATCH%"
  ]

  MAIL_LIST_KEYWORDS = [
    "%OS_MATCH%", "%OS_ALL%", "%HOST_MATCH%", "%HOST_ALL%", "%HOSTINFO_MATCH%", "%HOSTINFO_ALL%", "%DISPLAY_NAME_MATCH%", "%DISPLAY_NAME_ALL%",
    "%S_CATEGORY_MATCH%","%S_CATEGORY_ALL%", "%C_CATEGORY_MATCH%","%C_CATEGORY_ALL%","%HOST_LINKS_MATCH%", "%HOST_LINKS_ALL%",
    "%VULTITLE_ALL%","%VULTITLE_MATCH%","%VULINFO_MATCH%","%VULINFO_ALL%","%VUL_LINKS_MATCH%","%VUL_LINKS_ALL%",
    "%VUL_HOSTS_MATCH%", "%VUL_DISPLAY_NAME_MATCH%",
    "%SIDfmID_MATCH%", "%SIDfm_LINKS_MATCH%", "%MS_LINKS_MATCH%", "%SIDfmID_ALL%", "%SIDfm_LINKS_ALL%", "%MS_LINKS_ALL%", "%KB_MATCH%", "%KB_ALL%",
    "%APP_MATCH%", "%PRODUCT_MATCH%", "%LPRODUCT_MATCH%", "%APP_ALL%", "%PRODUCT_ALL%", "%LPRODUCT_ALL%",
    "%VULSYNC_ALL_HOST%", "%VULSYNC_ALL_DISPLAY_NAME%",
    "%VULSYNC_INFO_REGI_ALL%", "%VULSYNC_INFO_RENEW_ALL%", "%VULSYNC_INFO_DEL_ALL%","%VULSYNC_REGI_ALL%", "%VULSYNC_RENEW_ALL%", "%VULSYNC_DEL_ALL%",
    "%VULSYNC_REGI_HOST_ALL%", "%VULSYNC_REGI_DISPLAY_NAME_ALL%", "%VULSYNC_RENEW_HOST_ALL%", "%VULSYNC_RENEW_DISPLAY_NAME_ALL%", "%VULSYNC_DEL_HOST_ALL%", "%VULSYNC_DEL_DISPLAY_NAME_ALL%",
    "%VULSYNC_INFO_REGI_MATCH%", "%VULSYNC_INFO_RENEW_MATCH%", "%VULSYNC_INFO_DEL_MATCH%", "%VULSYNC_REGI_MATCH%", "%VULSYNC_RENEW_MATCH%", "%VULSYNC_DEL_MATCH%",
    "%VULSYNC_REGI_HOST_MATCH%", "%VULSYNC_REGI_DISPLAY_NAME_MATCH%", "%VULSYNC_RENEW_HOST_MATCH%", "%VULSYNC_RENEW_DISPLAY_NAME_MATCH%", "%VULSYNC_DEL_HOST_MATCH%", "%VULSYNC_DEL_DISPLAY_NAME_MATCH%"
  ]

  def send_mail(mail)
    @mail = mail
    mail(
      from: @mail[:from],
      to: @mail[:to],
      subject: @mail[:subject],
      body: @mail[:message],
      content_type: "text/plain"
    ) 
  end
 
  #文字列(template)からキーワードを抽出する。件数表示・データの限定に対応
  #:type = "default"は件数表示またはデータの限定をしないもの
  #:type = "case"は件数表示
  #:type = "top"は先頭から〇件のデータを表示
  #:type = "bottom"は末尾から〇件のデータを表示
  #necessary_data_numに必要なデータ数が入る。(数値またはnil。nilは全データの数)
  def self.get_keywords(template)
    hit_keywords = {}
    MAIL_KEYWORDS.each do |keyword|
      s_keyword = keyword.slice(0, keyword.length - 1)
      is_list_keyword = MAIL_LIST_KEYWORDS.include?(keyword)
      s_template = template
      no_more_keyword = false
      while no_more_keyword == false do
        hit_idx = s_template ? s_template.index(s_keyword) : nil
        if !hit_idx then
          no_more_keyword = true
        else
          target_idx = hit_idx + s_keyword.length
          next_chars = s_template.slice(target_idx..target_idx + 1)
          if next_chars[0] == "%" then
            hit_keywords[keyword] = {
              :keyword => keyword, 
              :type => "default",
              :necessary_data_num => nil
            }
            s_template = s_template.slice(target_idx + 1..s_template.length)
          elsif next_chars == ":C" && is_list_keyword then
            if s_template[target_idx + 2] == "-" then
              closing_char_idx = s_template.index("%", hit_idx + 1)
              break if !closing_char_idx
              num = s_template.slice(target_idx + 3..closing_char_idx - 1)
              if num.match(/\A[0-9]+\z/) then
                correct_kwd = s_template.slice(hit_idx..closing_char_idx)
                hit_keywords[correct_kwd] = {
                  :keyword => keyword,
                  :type => "case",
                  :necessary_data_num => ("-" + num).to_i
                }
              end
              s_template = s_template.slice(closing_char_idx + 1..s_template.length)
            elsif s_template[target_idx + 2] == "%" then
              correct_kwd = "#{s_keyword}#{next_chars}%"
              hit_keywords[correct_kwd] = {
                :keyword => keyword,
                :type => "case", 
                :necessary_data_num => nil
              } 
              s_template = s_template.slice(target_idx + 3..s_template.length)
            else
              s_template = s_template.slice(hit_idx + 1..s_template.length)
            end
          elsif (next_chars == ":T" || next_chars == ":B") && is_list_keyword then 
            closing_char_idx = s_template.index("%", hit_idx + 1)
            break if !closing_char_idx 
            num = s_template.slice(target_idx + 2..closing_char_idx - 1)
            if num.match(/\A[0-9]+\z/) then
              correct_kwd = s_template.slice(hit_idx..closing_char_idx)
              hit_keywords[correct_kwd] = {
                :keyword => keyword,
                :type => (next_chars == ":T" ? "top" : "bottom"),
                :necessary_data_num => num.to_i
              }
            end
            s_template = s_template.slice(closing_char_idx + 1..s_template.length)
          else
            s_template = s_template.slice(target_idx + 1..s_template.length)  
          end
        end
      end
    end
    return hit_keywords
  end    

  def self.replace_keywords(template, keywords_with_values)
    new_template = template
    keywords_with_values.each do |keyword, value|
      new_template = new_template.gsub(/#{keyword}/, value.to_s)
    end 
    return new_template
  end 

  #キーワード変換で使うメソッド (lambdaのメソッドも後に変更予定)
  
  #脆弱性同期時の脆弱性情報一覧(タイトルとリンクのみ)
  def self.create_vulsync_list(vuls, setting_host_name, setting_protocol)
    list = []
    vuls.each do |vul_info|
      link = Rails.application.routes.url_helpers.url_for(
        :host => setting_host_name,
        :protocol => setting_protocol,
        :controller => :sidfm_vulnerability,
        :action => :index,
        :id => vul_info[:html_id]
      )
      list << "#{vul_info[:title]}\n#{link}"
    end
    list
  end

  #脆弱性同期時の脆弱性情報一覧
  def self.create_vulsync_info_list(vuls, setting_host_name, setting_protocol, lambda_block)
    list = []
    vuls.each do |vul_info|
      htmlid = vul_info[:html_id]
      ms_link = nil
      vul_sidfm_info = []
      if htmlid < 0
        ms_link = "https://www.catalog.update.microsoft.com/Search.aspx?q=KB#{-htmlid}"
      end
      if htmlid < 0 then
        sidfmd_info = nil
        Sidfm.sidapi do |o|
          sidfmd_info = o.find_vulns_by_mskb(-htmlid)
        end
        if sidfmd_info && sidfmd_info["vulns"] && sidfmd_info["vulns"].size > 0 then
          sidfmd_info["vulns"].each do |info|
            id = info["id"]
            link = Rails.application.routes.url_helpers.url_for(
              :host => setting_host_name,
              :protocol => setting_protocol,
              :controller => :sidfm_informations,
              :action => :vuln,
              :id => id
            )
            title = "#{id} #{info["title"]}"
            vul_sidfm_info << "#{title}\n#{link}"
          end
        end
      else
        link = Rails.application.routes.url_helpers.url_for(
          :host => setting_host_name,
          :protocol => setting_protocol,
          :controller => :sidfm_informations,
          :action => :vuln,
          :id => htmlid
        )
        vul_sidfm_info << link
      end
      vul_link = Rails.application.routes.url_helpers.url_for(
        :host => setting_host_name,
        :protocol => setting_protocol,
        :controller => :sidfm_vulnerability,
        :action => :index,
        :id => vul_info[:html_id]
      )
      list << lambda_block.(vul_info, vul_link, ms_link, vul_sidfm_info)
    end
    list
  end

  #脆弱性同期時のホスト名及び表示名
  def self.create_vulsync_hostnames(vuls, target)
    list = {} #表示名を一意にしない
    vuls.each do |vul_info|
      vul_info[:sri_cvss_status_ids].each do |data|
        if data[:sidfmd_host_id] && data[:sidfmd_host_id] != 0 then
          host = SidfmdHost.find_by(:id => data[:sidfmd_host_id])
          list[data[:sidfmd_host_id]] = (target == 'hostname' ? host.hostname : (host.ext_name ? host.ext_name : host.hostname)) if host
        end
      end
    end
    list = list.values.sort
  end

  #脆弱性同期時の同期対象となった全てのホストのホスト名・表示名(条件のフィルタなし)
  def self.create_vulsync_all_hostnames(host_ids, target)
    list = {} #表示名を一意にしない
    host_ids.each do |host_id|
      host = SidfmdHost.find_by(:id => host_id)
      list[host_id] = (target == 'hostname' ? host.hostname : (host.ext_name ? host.ext_name : host.hostname)) if host
    end
    list = list.values.sort
  end

  #キーワードとデータの対応を返す
  #def self.assign_data_to_keywords(keywords, hosts_content, filtered_hosts_content, vuls_content, filtered_vuls_content, rule) #self.get_keywordsで取得したkeywordと、一覧データと、ルール（レコード）を引数にとる
  def self.assign_data_to_keywords(keywords, data_for_keyword, rule)
    category_host_ids = nil
    if data_for_keyword[:category_id] && data_for_keyword[:category_id].to_i > 0 then
      category_host_ids = SidfmdCategoriesHost.where(:sidfmd_category_id => data_for_keyword[:category_id]).distinct.pluck(:sidfmd_host_id)
    end
    hosts_content = data_for_keyword[:hosts_content]
    filtered_hosts_content = data_for_keyword[:filtered_hosts_content]
    vuls_content = data_for_keyword[:vuls_content]
    filtered_vuls_content = data_for_keyword[:filtered_vuls_content]
    if data_for_keyword[:vulsync_content] then
      vulsync_content_add = data_for_keyword[:vulsync_content][:add]
      vulsync_content_modify = data_for_keyword[:vulsync_content][:modify]
      vulsync_content_remove = data_for_keyword[:vulsync_content][:remove]
    else
      vulsync_content_add = []
      vulsync_content_modify = []
      vulsync_content_remove = []
    end
    if data_for_keyword[:filtered_vulsync_content] then
      filtered_vulsync_content_add = data_for_keyword[:filtered_vulsync_content][:add]
      filtered_vulsync_content_modify = data_for_keyword[:filtered_vulsync_content][:modify] 
      filtered_vulsync_content_remove = data_for_keyword[:filtered_vulsync_content][:remove]
    else
      filtered_vulsync_content_add = []
      filtered_vulsync_content_modify = []
      filtered_vulsync_content_remove = []
    end
    keywords_list = keywords.values.map{|kwd| kwd[:keyword]}
    hostinfo_is_necessary = (["%HOSTINFO_MATCH%", "%HOSTINFO_ALL%"] - keywords_list).size != 2
    vulinfo_is_necessary = keywords_list.select{|key| key =~ /%VULINFO_MATCH%|%VULINFO_ALL%|%VULSYNC_INFO_REGI_ALL%|%VULSYNC_INFO_RENEW_ALL%|%VULSYNC_INFO_DEL_ALL%|%VULSYNC_INFO_REGI_MATCH%|%VULSYNC_INFO_RENEW_MATCH%|%VULSYNC_INFO_DEL_MATCH%/ }.any?
    setting_host_name = Setting.host_name
    setting_protocol = Setting.protocol
    if hostinfo_is_necessary then
      create_host_info = ->(host, host_info, host_link, pkgs_size, apps_size, lapps_size, lproducts_size){ #ホスト情報一覧のデータ出力に使用 
        host_status_ids = host_info[:status_ids]
        host_due_dates_unfinished = host_info[:due_dates_unfinished]
        return ret = 
          "#{host_info[:display_name]}\n" + 
          "#{host_link}\n" + 
          "OS:#{(host_info[:os] and host_info[:os][:osname] and host_info[:os][:osname].size > 0) ? host_info[:os][:osname] : "---"}\n" +
          "システムカテゴリ:#{host_info[:system_category] ? host_info[:system_category][:name] : "なし"}" +
          "   カスタムカテゴリ:#{(host_info[:no_system_categories] && host_info[:no_system_categories].any?) ? host_info[:no_system_categories].map{|cc| cc[:name]}.join(', ') : "なし"}\n" +
          "対応:CVSS値を元にした場合、#{host_info[:warning][:cvss] ? "要" : "不要"}。SRI値を元にした場合、#{host_info[:warning][:sri] ? "要" : "不要"}。\n" +
          "最大SRI値:#{if host_status_ids.size > 0 then
                         case host_info[:max_sri]
                         when SidfmdIssueSri::VALUES[0] then "重大"
                         when SidfmdIssueSri::VALUES[1] then "高"
                         when SidfmdIssueSri::VALUES[2] then "中"
                         when SidfmdIssueSri::VALUES[3] then "低"
                         when SidfmdIssueSri::VALUES[4] then "無"
                         end
                       else
                         "---"
                       end
                   }" +
          "   最大CVSS値:#{if host_info[:cvss].size > 0 then
                             case host_info[:max_cvss][:label]
                               when :notreg then "---"
                               else sprintf('%.1f', (host_info[:max_cvss][:score]) )
                             end
                           else
                             "---"
                           end
                         }" +   
          "   影響範囲:#{if host_status_ids.size > 0 then
                           "#{SidfmdArea.where(:area_id => host_info[:max_area_id]).first.name}"
                         else
                           "---"
                         end
                       }" +
          "   攻撃コード:#{if host_status_ids.size > 0 then 
                             case host_info[:max_cvss][:label]
                             when :notreg then
                               "---"
                             else
                               if host_info[:exploitable] then
                                 "あり"
                               else
                                 "なし"
                               end
                             end
                           else
                             "なし"
                           end
                         }\n" + 
          "対応状況: 未対策#{host_status_ids.count(1)}件  対策中#{host_status_ids.count(2)}件 対策済#{host_status_ids.count(3)}件   影響無#{host_status_ids.count(4)}件\n" +
          "対策予定日設定済:#{if host_due_dates_unfinished.size > 0 then
                                if host_due_dates_unfinished.compact.size == 0 then
                                  "#{sprintf('%.1f', 0.0)}%"
                                else
                                  "#{sprintf('%.1f', (host_due_dates_unfinished.inject(0) {|r, x| r += 1 if (x and x.size > 0); r }.to_f / host_due_dates_unfinished.size.to_f * 100.0))}%"
                                end
                              else
                                "---"
                              end
                            }" +
          "   対処率:#{if host_status_ids.size > 0 then
                      "#{sprintf('%.1f', (host_status_ids.inject(0) {|r, x|
                           r += 1 if SidfmdIssue::STATUS_FINISHED.include?(x)
                           r
                         }.to_f / host_status_ids.size * 100.0 ))
                       }%"
                     else
                       "---"
                     end
                   }\n" +
          "検出パッケージ数:#{pkgs_size}" +
          "   検出アプリケーション数:#{apps_size}" +
          "   手動登録プロダクト数:#{lapps_size}" +
          "   ローカルプロダクト数#{lproducts_size}\n" + 
          "同期状態:#{host.is_syncing ? "同期中" : "非同期"}" +
          "   エージェントの使用状態:#{host.is_agent ? "使用" : "不使用"}\n" + 
          "最終確認日時:#{host.get_display_last_checked_at}" +
          "#{host.memo ? "\nメモ:#{host.memo}" : ""}"                                                       
      }
    end
    if vulinfo_is_necessary then
      create_vul_info = ->(vul_info, vul_link, ms_link, vul_sidfm_info){
        vul_status_ids = vul_info[:status_ids]
        vul_due_dates_unfinished = vul_info[:due_dates_unfinished]
        html_id = vul_info[:html_id]
        updated_on = Issue.where(:id => SidfmdIssue.where(:html_id => html_id).select(:issue_id)).maximum(:updated_on)
        ret = 
          "#{
            html_id < 0 ? "[KB#{-html_id}]#{vul_info[:title]}" : "[#{html_id}]#{vul_info[:title]}"
          }\n" +
          "#{vul_link}\n" +
          "関連するホスト:#{vul_info[:hosts] ? vul_info[:hosts].map{|host| host[:display_name]}.sort.join(", ") : "なし"}\n" +
          "システムカテゴリ:#{if vul_info[:categories] then
                                s_cats = vul_info[:categories].map{|c| c[:is_system] ? c[:name] : nil}.compact.sort
                                if s_cats.size > 0 then
                                  s_cats.join(", ")
                                else
                                  "なし"
                                end
                              else
                                "なし"
                              end
                            }" +
          "   カスタムカテゴリ:#{if vul_info[:categories] then
                                   c_cats = vul_info[:categories].map{|c| !c[:is_system] ? c[:name] : nil}.compact
                                   if c_cats.size > 0 then
                                     c_cats.join(", ")
                                   else
                                     "なし"
                                   end
                                 else
                                   "なし"
                                 end
                               }\n" + 
          "対応:CVSS値を元にした場合、#{vul_info[:warning][:cvss] ? "要" : "不要"}。SRI値を元にした場合、#{vul_info[:warning][:sri] ? "要" : "不要"}。\n" +
          "最大SRI値:#{if vul_info[:max_sri] then  
                         case vul_info[:max_sri]
                         when SidfmdIssueSri::VALUES[0] then "重大"
                         when SidfmdIssueSri::VALUES[1] then "高"
                         when SidfmdIssueSri::VALUES[2] then "中"
                         when SidfmdIssueSri::VALUES[3] then "低"
                         when SidfmdIssueSri::VALUES[4] then "無"
                         end
                       else
                         "---"
                       end
                     }" +
          "   最大CVSS値:#{case vul_info[:cvss][:label]
                             when :notreg then 
                               if html_id < 0 then "n/a"
                               else "---"
                               end
                             else sprintf('%.1f', (vul_info[:cvss][:score]) )
                           end
                         }" +
          "   影響範囲:#{SidfmdArea.where(:area_id => vul_info[:softek][:area_id]).first.name}" + 
          "   攻撃コード:#{case vul_info[:cvss][:label]
                           when :notreg then
                             if html_id < 0 then "n/a"
                             else "---"
                             end
                           else
                             if vul_info[:exploitable] then
                               "あり"
                             else
                               "なし"
                             end
                           end
                         }\n" +
          "対応状況: 未対策#{vul_status_ids.count(1)}件  対策中#{vul_status_ids.count(2)}件 対策済#{vul_status_ids.count(3)}件   影響無#{vul_status_ids.count(4)}件\n" +    
          "検出日:#{vul_info[:min_created_on][:display]}" +
          "   更新日:#{updated_on ? updated_on.localtime.strftime('%Y/%m/%d') : '---'}" +
          "   検出後最長経過日数:#{vul_info[:min_elapsed_created_on][:display] >= 0 ? vul_info[:min_elapsed_created_on][:display] : "---"}" +
          "   対策予定日設定済:#{if vul_due_dates_unfinished.size > 0 then
                                 if vul_due_dates_unfinished.compact.size == 0 then
                                   "#{sprintf('%.1f', 0.0)}%"
                                 else
                                   "#{sprintf('%.1f', (vul_due_dates_unfinished.inject(0) {|r, x| r += 1 if (x and x.size > 0); r }.to_f / vul_due_dates_unfinished.size.to_f * 100.0))}%"
                                 end
                               else
                                 "---"
                               end
                              }" +
          "   対処率:#{if vul_status_ids.size > 0 then
                      "#{sprintf('%.1f', (vul_status_ids.inject(0) {|r, x|
                           r += 1 if SidfmdIssue::STATUS_FINISHED.include?(x)
                           r
                         }.to_f / vul_status_ids.size * 100.0 ))
                       }%"
                      else
                       "---"
                      end
                     }\n" 
          if html_id < 0 then
            ret += "KB番号:KB#{-html_id}\n" +
            "Microsoft Update カタログリンク:\n" +
            "#{ms_link}" + 
            (vul_sidfm_info.size > 0 ? "\nSIDfm情報:\n#{vul_sidfm_info.join("\n")}" : "")
          else
            #CVEIDが同じものがある場合は、
            #c3_update_datetimeがあればc3_update_datetime, 
            #c2_update_datetimeがあればc2_update_datetimeで最も新しいもの1つを採用する。
            #両方無い場合はidが最も大きいものを採用する。
            SidfmdVvCve.where(:sidfmd_vul_view_id => SidfmdVulView.where(:html_id => html_id).select(:id))
                       .where(%|
                         id = (
                           SELECT id
                           FROM sidfmd_vv_cves AS cve_table2
                           WHERE sidfmd_vv_cves.sidfmd_vul_view_id = cve_table2.sidfmd_vul_view_id AND sidfmd_vv_cves.cve_id = cve_table2.cve_id                    ORDER BY 
                           CASE
                           WHEN c3_update_datetime IS NOT NULL THEN
                             100
                           WHEN c2_update_datetime IS NOT NULL THEN
                             200
                           ELSE
                             300
                           END,
                           c3_update_datetime,
                           c2_update_datetime,
                           id
                           LIMIT 1
                         )
                       |).order('cve_id COLLATE "C"').each_with_index do |cve, idx|
                         ret += "CVSS:\n" if idx == 0
                         c2_vector = cve.c2_vector_index
                         c3_vector = cve.c3_vector_index
                         ret += if c2_vector and c3_vector then
                                  "#{cve.cve_id}: CVSS V3: #{c3_vector}, CVSS V2: #{c2_vector}"
                                elsif c3_vector then
                                  "#{cve.cve_id}: CVSS V3: #{c3_vector}"
                                elsif c2_vector then
                                  "#{cve.cve_id}: CVSS V2: #{c2_vector}"
                                else
                                  "#{cve.cve_id}: 指標未登録"
                                end
                         ret += "\n"
                       end
            ret += "SIDfmID:#{html_id}\n" +
                   "脆弱性情報の詳細ページへのリンク:\n#{vul_sidfm_info.join("\n")}"
          end
          ret
      }
    end
    limit_num = MAIL_LIMIT_DATA_NUM
    status_not_conf = 0
    status_on_going = 0
    status_fixed = 0
    status_no_affect = 0
    not_fixed_sri_val = 0
    not_fixed_cvss_val = 0
    sri_critical = 0
    sri_high = 0
    sri_medium = 0
    sri_low = 0
    sri_none = 0
    cvss_critical = 0
    cvss_high = 0
    cvss_medium = 0
    cvss_low = 0
    cvss_none = 0
    vul_fixed = 0
    if keywords_list.select{|key|
      key =~ /%HOSTINFO_ALL%|%HOST_ALL%|%OS_RATE_ALL%|%OS_ALL%|%S_CATEGORY_ALL%|%C_CATEGORY_ALL%|%HOST_LINKS_ALL%|%APP_ALL%|%PRODUCT_ALL%|%LPRODUCT_ALL%|%DISPLAY_NAME_ALL%/
    }.size != 0 then
      hosts_size = 0 
      hostnames = []
      display_names = []
      osnames_with_count = {}
      hosts_info = []
      s_categories = []
      c_categories = []
      hosts_links = []
      all_apps = []
      all_lapps= []
      all_lproducts = []
      is_hostinfo_word = keywords_list.include?("%HOSTINFO_ALL%")
      is_apps_word = keywords_list.include?("%APP_ALL%")  || is_hostinfo_word
      is_lapp_word = keywords_list.include?("%PRODUCT_ALL%") || is_hostinfo_word
      is_lproducts_word = keywords_list.include?("%LPRODUCT_ALL%") || is_hostinfo_word
      is_link_word = keywords_list.include?("%HOST_LINKS_ALL%") || is_hostinfo_word
      hosts_content.each do |host_info|
        if category_host_ids then
          next unless category_host_ids.include?(host_info[:sidfmd_host_id])
        end
        if data_for_keyword[:host_ids] then
          next unless data_for_keyword[:host_ids].include?(host_info[:sidfmd_host_id])
        end
        hosts_size += 1
        if is_apps_word || is_lapp_word || is_lproducts_word then   
          host = SidfmdHost.find(host_info[:sidfmd_host_id])
          if is_apps_word then 
            queue = host.sidfmd_queues.order(:created_at => :desc).first
            if queue then
              apps = queue.sidfmd_queue_apps
              pkgs_size = queue.sidfmd_queue_pkgs.size
            else
              apps = []
              pkgs_size = 0
            end
            all_apps.push(*apps.map{|app| "#{app.name} #{app.version}\n#{app.path}"})
          end
          if is_lapp_word then 
            lapps = host.sidfmd_host_apps
            all_lapps.push(*lapps.map{|app| app.get_name})
          end
          if is_lproducts_word then
            lproducts = host.sidfmd_host_lapps
            all_lproducts.push(*lproducts.map{|lapp| lapp.get_name})
          end
        end
        hostnames << host_info[:hostname]
        display_names << host_info[:display_name]
        os = host_info[:os]
        if os then 
          os_name = os[:osname] ? os[:osname] : "（不明）"
        else
          os_name = "（不明）"
        end
        if osnames_with_count[os_name] then 
          osnames_with_count[os_name] += 1 
        else 
          osnames_with_count[os_name] = 1 
        end
        if is_link_word then 
          host_link = Rails.application.routes.url_helpers.url_for(
                       :host => setting_host_name,
                       :protocol => setting_protocol,
                       :controller => :sidfm_host,
                       :action => :index,
                       :id => host_info[:sidfmd_host_id]
                     )
          hosts_links << "#{host_info[:display_name]}\n#{host_link}"
        end
        if is_hostinfo_word then
          hosts_info << create_host_info.(host, host_info, host_link, pkgs_size, apps.size, lapps.size, lproducts.size)
        end
        if host_info[:system_category] && host_info[:system_category][:name] then
          s_categories << host_info[:system_category][:name] 
        end
        if host_info[:no_system_categories].size > 0 then 
          host_info[:no_system_categories].each do |cat|
            c_categories << cat[:name] 
          end
        end
      end
    end
    if keywords_list.select{|key|
      key =~ /%RISK_RATE_SRI_ALL%|%UNHANDLED_RATE_SRI_ALL%|%RISK_RATE_CVSS_ALL%|%UNHANDLED_RATE_CVSS_ALL%|%HANDLING_RATE_ALL%|%VULINFO_ALL%|%VULTITLE_ALL%|%VUL_LINKS_ALL%|%SIDfmID_ALL%|%SIDfm_LINKS_ALL%|%KB_ALL%|%MS_LINKS_ALL%/
    }.size != 0 then
      vul_titles = []
      vuls_links = []
      vuls_size = 0
      ms_links = []
      sidfm_info_links = []
      sidfm_ids = []
      kb_nums = []
      vuls_info = []
      is_handling_rate_word = keywords_list.include?("%HANDLING_RATE_ALL%")
      is_sri_word = keywords_list.include?("%RISK_RATE_SRI_ALL%")
      is_cvss_word = keywords_list.include?("%RISK_RATE_CVSS_ALL%")
      is_vulinfo_word = keywords_list.include?("%VULINFO_ALL%")
      is_vul_link_word = keywords_list.include?("%VUL_LINKS_ALL%") || is_vulinfo_word
      is_sidinfo_word = (["%SIDfmID_ALL%", "%SIDfm_LINKS_ALL%", "%VULINFO_ALL%"] - keywords_list).size != 3
      vuls_content.each do |vul_info|
        if category_host_ids then
          next if (category_host_ids - vul_info[:hosts].map{|ht| ht[:id] }).size == category_host_ids.size
        end
        if data_for_keyword[:host_ids] then
          next if (data_for_keyword[:host_ids] - vul_info[:hosts].map{|ht| ht[:id] }).size == data_for_keyword[:host_ids].size
        end
        vuls_size += 1
        htmlid = vul_info[:html_id]
        ms_link = nil
        vul_sidfm_info = []
        if htmlid < 0
          kb_nums << "#{-htmlid}"
          ms_link = "https://www.catalog.update.microsoft.com/Search.aspx?q=KB#{-htmlid}"
          ms_links << "#{vul_info[:title]}\n#{ms_link}"
        else
          ms_link = nil
        end
        if is_sidinfo_word then
          if htmlid < 0 then
            sidfmd_info = nil
            Sidfm.sidapi do |o|
              sidfmd_info = o.find_vulns_by_mskb(-htmlid)
            end
            if sidfmd_info && sidfmd_info["vulns"] && sidfmd_info["vulns"].size > 0 then
              sidfmd_info["vulns"].each do |info|
                id = info["id"]
                link = Rails.application.routes.url_helpers.url_for( 
                        :host => setting_host_name,
                        :protocol => setting_protocol,
                        :controller => :sidfm_informations,
                        :action => :vuln, 
                        :id => id 
                      )
                title = "#{id} #{info["title"]}"  
                vul_sidfm_info << "#{title}\n#{link}"
                sidfm_ids << id.to_s
                sidfm_info_links << "#{title}\n#{link}"
              end
            end 
          else
            link = Rails.application.routes.url_helpers.url_for(
                    :host => setting_host_name,
                    :protocol => setting_protocol,
                    :controller => :sidfm_informations,
                    :action => :vuln,
                    :id => htmlid
                   )        
            vul_sidfm_info << link
            sidfm_ids << htmlid.to_s
            sidfm_info_links << "#{vul_info[:title]}\n#{link}"
          end
        end
        if is_vul_link_word then
          vul_link = Rails.application.routes.url_helpers.url_for(
                       :host => setting_host_name,
                       :protocol => setting_protocol,
                       :controller => :sidfm_vulnerability,
                       :action => :index,
                       :id => vul_info[:html_id]
                     )
          vuls_links << "#{vul_info[:title]}\n#{vul_link}"
        end
        if is_vulinfo_word then
          vuls_info << create_vul_info.(vul_info, vul_link, ms_link, vul_sidfm_info)
        end
        not_fixed_warning = vul_info[:not_fixed_warning]
        min_status_id = vul_info[:min_status_id]
        vul_titles << vul_info[:title]
        not_fixed_sri_val += 1 if not_fixed_warning[:sri]
        not_fixed_cvss_val += 1 if not_fixed_warning[:cvss]
        if is_handling_rate_word then 
          case min_status_id
            when SidfmdIssue::STATUS_NOTCONFIRMED then status_not_conf += 1
            when SidfmdIssue::STATUS_ONGOING then status_on_going += 1
            when SidfmdIssue::STATUS_FIXED then status_fixed += 1
            when SidfmdIssue::STATUS_NOTAFFECT then status_no_affect += 1
            else status_no_affect += 1
          end
        end
        if SidfmdIssue::STATUS_UNFINISHED.include?(min_status_id) then
          if is_sri_word then
            case vul_info[:max_sri]
            when SidfmdIssueSri::VALUES[0] then
              sri_critical += 1
            when SidfmdIssueSri::VALUES[1] then
              sri_high += 1
            when SidfmdIssueSri::VALUES[2] then
              sri_medium += 1
            when SidfmdIssueSri::VALUES[3] then
              sri_low += 1
            when SidfmdIssueSri::VALUES[4] then
              sri_none += 1
            end
          end
          if is_cvss_word then
            case vul_info[:cvss][:label]
            when :notreg then
              cvss_none += 1
            when :d4 then
              cvss_critical += 1
            when :d3 then
              cvss_high += 1
            when :d2 then
              cvss_medium += 1
            when :d1 then
              cvss_low += 1
            end
          end
        else
          vul_fixed += 1
        end
      end
    end
    match_status_not_conf = 0
    match_status_on_going = 0
    match_status_fixed = 0
    match_status_no_affect = 0
    match_not_fixed_sri_val = 0
    match_not_fixed_cvss_val = 0
    match_sri_critical = 0
    match_sri_high = 0
    match_sri_medium = 0
    match_sri_low = 0
    match_sri_none = 0
    match_cvss_critical = 0
    match_cvss_high = 0
    match_cvss_medium = 0
    match_cvss_low = 0
    match_cvss_none = 0
    match_vul_fixed = 0
    if keywords_list.select{|key|
      key =~ /%OS_RATE_MATCH%|%OS_MATCH%|%HOST_MATCH%|%HOSTINFO_MATCH%|%S_CATEGORY_MATCH%|%C_CATEGORY_MATCH%|%HOST_LINKS_MATCH%|%APP_MATCH%|%PRODUCT_MATCH%|%LPRODUCT_MATCH%|%DISPLAY_NAME_MATCH%/
    }.size != 0 then
      match_hosts_size = filtered_hosts_content.size
      match_hostnames = []
      match_display_names = []
      match_osnames_with_count = {}
      match_hosts_info = []
      match_s_categories = []
      match_c_categories = []
      match_hosts_links = []
      match_all_apps = []
      match_all_lapps = []
      match_all_lproducts = []
      is_hostinfo_word = keywords_list.include?("%HOSTINFO_MATCH%")
      is_apps_word = keywords_list.include?("%APP_MATCH%")  || is_hostinfo_word
      is_lapp_word = keywords_list.include?("%PRODUCT_MATCH%" ) || is_hostinfo_word
      is_lproducts_word = keywords_list.include?("%LPRODUCT_MATCH%" ) || is_hostinfo_word
      is_link_word = keywords_list.include?("%HOST_LINKS_MATCH%") || is_hostinfo_word
      filtered_hosts_content.each do |host_info|
        if is_apps_word || is_lapp_word || is_lproducts_word then
          host = SidfmdHost.find(host_info[:sidfmd_host_id])
          if is_apps_word then
            queue = host.sidfmd_queues.order(:created_at => :desc).first
            if queue then
              apps = queue.sidfmd_queue_apps
              pkgs_size = queue.sidfmd_queue_pkgs.size
            else
              apps = []
              pkgs_size = 0
            end
            match_all_apps.push(*apps.map{|app| "#{app.name} #{app.version}\n#{app.path}"})
          end 
          if is_lapp_word then
            lapps = host.sidfmd_host_apps
            match_all_lapps.push(*lapps.map{|app| app.get_name})
          end
          if is_lproducts_word then
            lproducts = host.sidfmd_host_lapps
            match_all_lproducts.push(*lproducts.map{|lapp| lapp.get_name})
          end
        end
        match_hostnames << host_info[:hostname]
        match_display_names << host_info[:display_name]
        os = host_info[:os]
        if os then
          os_name = os[:osname] ? os[:osname] : "（不明）"
        else
          os_name = "（不明）"
        end
        if match_osnames_with_count[os_name] then
          match_osnames_with_count[os_name] += 1
        else
          match_osnames_with_count[os_name] = 1
        end
        if is_link_word then
          host_link = Rails.application.routes.url_helpers.url_for(
                       :host => setting_host_name,
                       :protocol => setting_protocol,
                       :controller => :sidfm_host,
                       :action => :index,
                       :id => host_info[:sidfmd_host_id]
                      )
          match_hosts_links << "#{host_info[:display_name]}\n#{host_link}"
        end
        if is_hostinfo_word then
          match_hosts_info << create_host_info.(host, host_info, host_link, pkgs_size, apps.size, lapps.size, lproducts.size)
        end
        if host_info[:system_category] && host_info[:system_category][:name] then
          match_s_categories << host_info[:system_category][:name]
        end
        if host_info[:no_system_categories].size > 0 then
          host_info[:no_system_categories].each do |cat|
            match_c_categories << cat[:name]
          end
        end
      end
    end
    if keywords_list.select{|key|
     key =~ /%RISK_RATE_SRI_MATCH%|%UNHANDLED_RATE_SRI_MATCH%|%RISK_RATE_CVSS_MATCH%|%UNHANDLED_RATE_CVSS_MATCH%|%HANDLING_RATE_MATCH%|%VULINFO_MATCH%|%VULTITLE_MATCH%|%VUL_LINKS_MATCH%|%SIDfmID_MATCH%|%SIDfm_LINKS_MATCH%|%KB_MATCH%|%MS_LINKS_MATCH%|%VUL_HOSTS_MATCH%|%VUL_DISPLAY_NAME_MATCH%/
    }.size != 0 then
      match_vuls_size = filtered_vuls_content.size
      match_vul_titles = []
      match_vuls_links = []
      match_ms_links = []
      match_sidfm_info_links = []
      match_sidfm_ids = []
      match_kb_nums = []
      match_vuls_info = []
      match_vul_hostnames = []
      match_vul_host_display_names = []
      is_handling_rate_word = keywords_list.include?("%HANDLING_RATE_MATCH%")
      is_sri_word = keywords_list.include?("%RISK_RATE_SRI_MATCH%")
      is_cvss_word = keywords_list.include?("%RISK_RATE_CVSS_MATCH%")
      is_vulinfo_word = keywords_list.include?("%VULINFO_MATCH%")
      is_vul_link_word = keywords_list.include?("%VUL_LINKS_MATCH%") || is_vulinfo_word
      is_sidinfo_word = (["%SIDfmID_MATCH%", "%SIDfm_LINKS_MATCH%", "%VULINFO_MATCH%"] - keywords_list).size != 3
      is_vul_hostnames_word = keywords_list.include?("%VUL_HOSTS_MATCH%")
      is_vul_host_display_names_word = keywords_list.include?("%VUL_DISPLAY_NAME_MATCH%")

      filtered_vuls_content.each do |vul_info|
        if is_vul_hostnames_word then
          match_vul_hostnames |= vul_info[:hosts].map{|host| host[:hostname]}
        end
        if is_vul_host_display_names_word then
          match_vul_host_display_names |= vul_info[:hosts].map{|host| host[:display_name]}
        end
        htmlid = vul_info[:html_id]
        vul_sidfm_info = []
        if htmlid < 0 then
          match_kb_nums << "#{-htmlid}" if htmlid < 0
          ms_link = "https://www.catalog.update.microsoft.com/Search.aspx?q=KB#{-htmlid}"
          match_ms_links << "#{vul_info[:title]}\n#{ms_link}"
        else 
          ms_link = nil
        end
        if is_sidinfo_word then
          if htmlid < 0 then
            sidfmd_info = nil
            Sidfm.sidapi do |o|
              sidfmd_info = o.find_vulns_by_mskb(-htmlid)
            end
            if sidfmd_info && sidfmd_info["vulns"] && sidfmd_info["vulns"].size > 0 then
              sidfmd_info["vulns"].each do |info|
                id = info["id"]
                link = Rails.application.routes.url_helpers.url_for(
                        :host => setting_host_name,
                        :protocol => setting_protocol,
                        :controller => :sidfm_informations,
                        :action => :vuln,
                        :id => id
                      )
                title = "#{id} #{info["title"]}"
                vul_sidfm_info << "#{title}\n#{link}"
                match_sidfm_ids << id.to_s
                match_sidfm_info_links << "#{title}\n#{link}"
              end
            end
          else
            link = Rails.application.routes.url_helpers.url_for(
                    :host => setting_host_name,
                    :protocol => setting_protocol,
                    :controller => :sidfm_informations,
                    :action => :vuln,
                    :id => htmlid
                   )
            vul_sidfm_info << link
            match_sidfm_ids << htmlid.to_s
            match_sidfm_info_links << "#{vul_info[:title]}\n#{link}"
          end
        end
        if is_vul_link_word then 
          vul_link = Rails.application.routes.url_helpers.url_for(
                       :host => setting_host_name,
                       :protocol => setting_protocol,
                       :controller => :sidfm_vulnerability,
                       :action => :index,
                       :id => vul_info[:html_id]
                     )
          match_vuls_links << "#{vul_info[:title]}\n#{vul_link}"
        end
        if is_vulinfo_word then
          match_vuls_info << create_vul_info.(vul_info, vul_link, ms_link, vul_sidfm_info)
        end
        not_fixed_warning = vul_info[:not_fixed_warning]
        min_status_id = vul_info[:min_status_id]
        match_vul_titles << vul_info[:title]
        match_not_fixed_sri_val += 1 if not_fixed_warning[:sri]
        match_not_fixed_cvss_val += 1 if not_fixed_warning[:cvss]
        if is_handling_rate_word then
          case min_status_id
            when SidfmdIssue::STATUS_NOTCONFIRMED then match_status_not_conf += 1
            when SidfmdIssue::STATUS_ONGOING then match_status_on_going += 1
            when SidfmdIssue::STATUS_FIXED then match_status_fixed += 1
            when SidfmdIssue::STATUS_NOTAFFECT then match_status_no_affect += 1
            else match_status_no_affect += 1
          end
        end
        if SidfmdIssue::STATUS_UNFINISHED.include?(min_status_id) then
          if is_sri_word then
            case vul_info[:max_sri]
            when SidfmdIssueSri::VALUES[0] then
              match_sri_critical += 1
            when SidfmdIssueSri::VALUES[1] then
              match_sri_high += 1
            when SidfmdIssueSri::VALUES[2] then
              match_sri_medium += 1
            when SidfmdIssueSri::VALUES[3] then
              match_sri_low += 1
            when SidfmdIssueSri::VALUES[4] then
              match_sri_none += 1
            end
          end
          if is_cvss_word then
            case vul_info[:cvss][:label]
            when :notreg then
              match_cvss_none += 1
            when :d4 then
              match_cvss_critical += 1
             when :d3 then
              match_cvss_high += 1
            when :d2 then
              match_cvss_medium += 1
            when :d1 then
              match_cvss_low += 1
            end
          end
        else
          match_vul_fixed += 1
        end
      end
    end

    sort_os_names = ->(os_info) { 
      return  os_info.keys.sort{|x, y|
        r = 0
        if x == "（不明）" then
          r = 1
        elsif y ==  "（不明）" then
          r = -1
        else
          r = os_info[y] <=> os_info[x]
          if r == 0 then
            r = x <=> y
          end
        end
        r
      }
    }
    os_list_description = ->(sorted_os_names, osnames_with_count_list, all_osnames_size){
      return ret = if sorted_os_names.size > 0 then
        sorted_os_names.map{|osname|
          "#{osname}: #{(osnames_with_count_list[osname].fdiv(all_osnames_size) * 100).round(1)}%"
        }.join(', ')
      else
        "対象OS無し"
      end
    }
    risk_rate_description = ->(c_percent, h_percent, m_percent, l_percent, n_percent, f_percent, risk_index){
      return ret = if risk_index == "sri" then
        "重大:#{c_percent >= 10 ? c_percent.round(1) : (c_percent >= 1 ? c_percent.round(2) : c_percent.round(3))}%," +
        "高:#{h_percent >= 10 ? h_percent.round(1) : (h_percent >= 1 ? h_percent.round(2) : h_percent.round(3))}%," +
        "中:#{m_percent >= 10 ? m_percent.round(1) : (m_percent >= 1 ? m_percent.round(2) : m_percent.round(3))}%," +
        "低:#{l_percent >= 10 ? l_percent.round(1) : (l_percent >= 1 ? l_percent.round(2) : l_percent.round(3))}%," +
        "無:#{n_percent >= 10 ? n_percent.round(1) : (n_percent >= 1 ? n_percent.round(2) : n_percent.round(3))}%," +
        "済:#{f_percent >= 10 ? f_percent.round(1) : (f_percent >= 1 ? f_percent.round(2) : f_percent.round(3))}%"  
      else
        "未登録:#{n_percent >= 10 ? n_percent.round(1) : (n_percent >= 1 ? n_percent.round(2) : n_percent.round(3))}%," +
        "10.0～9.0:#{c_percent >= 10 ? c_percent.round(1) : (c_percent >= 1 ? c_percent.round(2) : c_percent.round(3))}%," +
        "8.9～7.0:#{h_percent >= 10 ? h_percent.round(1) : (h_percent >= 1 ? h_percent.round(2) : h_percent.round(3))}%," +
        "6.9～4.0:#{m_percent >= 10 ? m_percent.round(1) : (m_percent >= 1 ? m_percent.round(2) : m_percent.round(3))}%," +
        "3.9～0.0#{l_percent >= 10 ? l_percent.round(1) : (l_percent >= 1 ? l_percent.round(2) : l_percent.round(3))}%," +
        "済:#{f_percent >= 10 ? f_percent.round(1) : (f_percent >= 1 ? f_percent.round(2) : f_percent.round(3))}%"
      end
    }
    handling_rate_description = ->(c_percent, g_percent, f_percent, n_percent){
      "未対策:#{c_percent >= 10 ? c_percent.round(1) : (c_percent >= 1 ? c_percent.round(2) : c_percent.round(3))}%," +
      "対策中:#{g_percent >= 10 ? g_percent.round(1) : (g_percent >= 1 ? g_percent.round(2) : g_percent.round(3))}%," +
      "対策済:#{f_percent >= 10 ? f_percent.round(1) : (f_percent >= 1 ? f_percent.round(2) : f_percent.round(3))}%," +
      "影響無:#{n_percent >= 10 ? n_percent.round(1) : (n_percent >= 1 ? n_percent.round(2) : n_percent.round(3))}%"
    }
    filter_list_data = ->(type, data_num, content, content_size, no_data_message, join_type, limit){
      return ret =
      if type == "default" then
        content_size > 0 ? content.slice(0..limit - 1).join(join_type) : no_data_message
      elsif type == "case"
        data_num.nil? ? content_size : (content_size + data_num > 0 ? content_size + data_num : 0)
      elsif type == "top" then
        content_size > 0 ? content.slice(0..data_num - 1).join(join_type) : no_data_message
      else
        content_size > 0 ? content.reverse.slice(0..data_num - 1).join(join_type) : no_data_message
      end
    }
    vuls_size = 1 if vuls_size == 0 #0除算を防ぐ
    match_vuls_size = 1 if match_vuls_size == 0
    opts  = {} #keywordがkeyでvalueにkeywordに対応するデータを入れる
    keywords.each do |filtered_keyword, data|
      keyword = data[:keyword]
      type = data[:type]
      data_num = data[:necessary_data_num]
      case keyword
      when "%RISK_RATE_SRI_ALL%" then
        c_percent = sri_critical.fdiv(vuls_size) * 100
        h_percent = sri_high.fdiv(vuls_size) * 100
        m_percent = sri_medium.fdiv(vuls_size) * 100
        l_percent = sri_low.fdiv(vuls_size) * 100
        n_percent = sri_none.fdiv(vuls_size) * 100
        f_percent = vul_fixed.fdiv(vuls_size) * 100
        opts[filtered_keyword] = risk_rate_description.(c_percent, h_percent, m_percent, l_percent, n_percent, f_percent, "sri")
      when "%UNHANDLED_RATE_SRI_ALL%" then
        opts[filtered_keyword] = "#{(not_fixed_sri_val.fdiv(vuls_size) * 100).to_i}%"
      when "%RISK_RATE_SRI_MATCH%" then
        c_percent = match_sri_critical.fdiv(match_vuls_size) * 100
        h_percent = match_sri_high.fdiv(match_vuls_size) * 100
        m_percent = match_sri_medium.fdiv(match_vuls_size) * 100
        l_percent = match_sri_low.fdiv(match_vuls_size) * 100
        n_percent = match_sri_none.fdiv(match_vuls_size) * 100
        f_percent = match_vul_fixed.fdiv(match_vuls_size) * 100
        opts[filtered_keyword] = risk_rate_description.(c_percent, h_percent, m_percent, l_percent, n_percent, f_percent, "sri")
      when "%UNHANDLED_RATE_SRI_MATCH%" then
        opts[filtered_keyword] = "#{(match_not_fixed_sri_val.fdiv(match_vuls_size) * 100).to_i}%"
      when "%RISK_RATE_CVSS_ALL%" then
        c_percent = cvss_critical.fdiv(vuls_size) * 100
        h_percent = cvss_high.fdiv(vuls_size) * 100
        m_percent = cvss_medium.fdiv(vuls_size) * 100
        l_percent = cvss_low.fdiv(vuls_size) * 100
        n_percent = cvss_none.fdiv(vuls_size) * 100
        f_percent = vul_fixed.fdiv(vuls_size) * 100
        opts[filtered_keyword] = risk_rate_description.(c_percent, h_percent, m_percent, l_percent, n_percent, f_percent, "cvss")
      when "%UNHANDLED_RATE_CVSS_ALL%"
        opts[filtered_keyword] = "#{(not_fixed_cvss_val.fdiv(vuls_size) * 100).to_i}%"
      when "%RISK_RATE_CVSS_MATCH%"
        c_percent = match_cvss_critical.fdiv(match_vuls_size) * 100
        h_percent = match_cvss_high.fdiv(match_vuls_size) * 100
        m_percent = match_cvss_medium.fdiv(match_vuls_size) * 100
        l_percent = match_cvss_low.fdiv(match_vuls_size) * 100
        n_percent = match_cvss_none.fdiv(match_vuls_size) * 100
        f_percent = match_vul_fixed.fdiv(match_vuls_size) * 100
        opts[filtered_keyword] = risk_rate_description.(c_percent, h_percent, m_percent, l_percent, n_percent, f_percent, "cvss")
      when "%UNHANDLED_RATE_CVSS_MATCH%" then
        opts[filtered_keyword] = "#{(match_not_fixed_cvss_val.fdiv(match_vuls_size) * 100).to_i}%"
      when "%HANDLING_RATE_ALL%" then
        c_percent = status_not_conf.fdiv(vuls_size) * 100
        g_percent = status_on_going.fdiv(vuls_size) * 100
        f_percent = status_fixed.fdiv(vuls_size) * 100
        n_percent = status_no_affect.fdiv(vuls_size) * 100
        opts[filtered_keyword] = handling_rate_description.(c_percent, g_percent, f_percent, n_percent)
      when "%HANDLING_RATE_MATCH%" then
        c_percent = match_status_not_conf.fdiv(match_vuls_size) * 100
        g_percent = match_status_on_going.fdiv(match_vuls_size) * 100
        f_percent = match_status_fixed.fdiv(match_vuls_size) * 100
        n_percent = match_status_no_affect.fdiv(match_vuls_size) * 100
        opts[filtered_keyword] = handling_rate_description.(c_percent, g_percent, f_percent, n_percent)
      when "%URL%" then
        opts[filtered_keyword] = Rails.application.routes.url_helpers.url_for(
          :host => setting_host_name, 
          :protocol => setting_protocol, 
          :controller => :sidfm_rule_setting,
          :action => :index
        )
      when "%TITLE%" then
        opts[filtered_keyword] = SidfmdRule::PAGE_TITLE
      when "%OS_RATE_ALL%" then
        opts[filtered_keyword] = os_list_description.(sort_os_names.(osnames_with_count), osnames_with_count, hosts_size)
      when "%OS_RATE_MATCH%" then
        opts[filtered_keyword] = os_list_description.(sort_os_names.(match_osnames_with_count), match_osnames_with_count, match_hosts_size)
      when "%OS_ALL%" then
        all_os_names = osnames_with_count.keys.select{|osname| osname != "（不明）"}.sort
        opts[filtered_keyword] = filter_list_data.(type, data_num, all_os_names, all_os_names.size, "対象のOSはありません。", ', ', limit_num)
      when "%OS_MATCH%" then
        match_all_os_names = match_osnames_with_count.keys.select{|osname| osname != "（不明）"}.sort
        opts[filtered_keyword] = filter_list_data.(type, data_num, match_all_os_names, match_all_os_names.size, "対象のOSはありません。", ', ', limit_num)
      when "%HOST_ALL%" then
        opts[filtered_keyword] = filter_list_data.(type, data_num, hostnames, hosts_size, "対象のホストはありません。", ', ', limit_num)
      when "%HOST_MATCH%" then
        opts[filtered_keyword] = filter_list_data.(type, data_num, match_hostnames, match_hosts_size, "対象のホストはありません。", ', ', limit_num)
      when "%DISPLAY_NAME_ALL%" then
        display_names = display_names.sort{|a, b| a.downcase <=> b.downcase}
        opts[filtered_keyword] = filter_list_data.(type, data_num, display_names, display_names.size, "対象のホストはありません。", ', ', limit_num)
      when "%DISPLAY_NAME_MATCH%" then
        match_display_names = match_display_names.sort{|a, b| a.downcase <=> b.downcase}
        opts[filtered_keyword] = filter_list_data.(type, data_num, match_display_names, match_display_names.size, "対象のホストはありません。", ', ', limit_num)
      when "%HOSTINFO_ALL%" then 
        opts[filtered_keyword] = filter_list_data.(type, data_num, hosts_info, hosts_info.size, "対象のホストはありません。", "\n\n", limit_num)
      when "%HOSTINFO_MATCH%" then
        opts[filtered_keyword] = filter_list_data.(type, data_num, match_hosts_info, match_hosts_info.size, "対象のホストはありません。", "\n\n", limit_num)
      when "%S_CATEGORY_ALL%" then
        s_categories = s_categories.uniq.sort
        opts[filtered_keyword] = filter_list_data.(type, data_num, s_categories, s_categories.size, "対象のシステムカテゴリはありません。", ', ', limit_num)
      when "%S_CATEGORY_MATCH%" then
        match_s_categories = match_s_categories.uniq.sort
        opts[filtered_keyword] = filter_list_data.(type, data_num, match_s_categories, match_s_categories.size, "対象のシステムカテゴリはありません。", ', ', limit_num)
      when "%C_CATEGORY_ALL%" then 
        c_categories = c_categories.uniq.sort
        opts[filtered_keyword] = filter_list_data.(type, data_num, c_categories, c_categories.size, "対象のカスタムカテゴリはありません。", ', ', limit_num) 
      when "%C_CATEGORY_MATCH%" then
        match_c_categories = match_c_categories.uniq.sort
        opts[filtered_keyword] = filter_list_data.(type, data_num, match_c_categories, match_c_categories.size, "対象のカスタムカテゴリはありません。", ', ', limit_num)
      when "%HOST_LINKS_ALL%" then
        opts[filtered_keyword] = filter_list_data.(type, data_num, hosts_links, hosts_links.size, "対象のホストはありません。", "\n\n", limit_num)  
      when "%HOST_LINKS_MATCH%" then
        opts[filtered_keyword] = filter_list_data.(type, data_num, match_hosts_links, match_hosts_links.size, "対象のホストはありません。", "\n\n", limit_num)
      when "%VULINFO_ALL%" then
        opts[filtered_keyword] = filter_list_data.(type, data_num, vuls_info, vuls_info.size, "対象の脆弱性はありません。", "\n\n", limit_num)
      when "%VULINFO_MATCH%" then
        opts[filtered_keyword] = filter_list_data.(type, data_num, match_vuls_info, match_vuls_info.size, "対象の脆弱性はありません。", "\n\n", limit_num)
      when "%VULTITLE_ALL%" then
        vul_titles.uniq!
        opts[filtered_keyword] = filter_list_data.(type, data_num, vul_titles, vul_titles.size, "対象の脆弱性はありません。", ",\n", limit_num)
      when "%VULTITLE_MATCH%" then
        opts[filtered_keyword] = filter_list_data.(type, data_num, match_vul_titles, match_vul_titles.size, "対象の脆弱性はありません。", ",\n", limit_num)
      when "%VUL_LINKS_ALL%" then
        opts[filtered_keyword] = filter_list_data.(type, data_num, vuls_links, vuls_links.size, "対象の脆弱性はありません。", "\n\n", limit_num)
      when "%VUL_LINKS_MATCH%" then
        opts[filtered_keyword] = filter_list_data.(type, data_num, match_vuls_links, match_vuls_links.size, "対象の脆弱性はありません。", "\n\n", limit_num)
      when "%VUL_HOSTS_MATCH%" then
        opts[filtered_keyword] = filter_list_data.(type, data_num, match_vul_hostnames.sort_by{|h_name| h_name.downcase}, match_vul_hostnames.size, "関連するホストはありません。", ', ', limit_num)
      when "%VUL_DISPLAY_NAME_MATCH%" then
        opts[filtered_keyword] = filter_list_data.(type, data_num, match_vul_host_display_names.sort_by{|d_name| d_name.downcase}, match_vul_host_display_names.size, "関連するホストはありません。", ', ', limit_num)
      when "%SIDfmID_ALL%" then
        sidfm_ids = sidfm_ids.uniq.sort
        opts[filtered_keyword] = filter_list_data.(type, data_num, sidfm_ids, sidfm_ids.size, "関連するSIDfmIDはありません。", ", ", limit_num)
      when "%SIDfmID_MATCH%" then
        match_sidfm_ids = match_sidfm_ids.uniq.sort
        opts[filtered_keyword] = filter_list_data.(type, data_num, match_sidfm_ids, match_sidfm_ids.size, "関連するSIDfmIDはありません。", ", ", limit_num)
      when "%SIDfm_LINKS_ALL%" then
        opts[filtered_keyword] = filter_list_data.(type, data_num, sidfm_info_links, sidfm_info_links.size, "関連する「脆弱性情報の詳細」ページはありません。", "\n\n", limit_num)
      when "%SIDfm_LINKS_MATCH%" then
        opts[filtered_keyword] = filter_list_data.(type, data_num, match_sidfm_info_links, match_sidfm_info_links.size, "関連する「脆弱性情報の詳細」ページはありません。", "\n\n", limit_num)
      when "%MS_LINKS_ALL%" then
        opts[filtered_keyword] = filter_list_data.(type, data_num, ms_links, ms_links.size, "関連する「Microsoft Update カタログ」はありません。", "\n\n", limit_num)
      when "%MS_LINKS_MATCH%" then
        opts[filtered_keyword] = filter_list_data.(type, data_num, match_ms_links, match_ms_links.size, "関連する「Microsoft Update カタログ」はありません。", "\n\n", limit_num)
      when "%KB_ALL%" then
        opts[filtered_keyword] = filter_list_data.(type, data_num, kb_nums, kb_nums.size, "関連するKB番号はありません。", ", ", limit_num)
      when "%KB_MATCH%" then
        opts[filtered_keyword] = filter_list_data.(type, data_num, match_kb_nums, match_kb_nums.size, "関連するKB番号はありません。", ", ", limit_num)
      when "%APP_ALL%" then
        all_apps = all_apps.uniq.sort
        opts[filtered_keyword] = filter_list_data.(type, data_num, all_apps, all_apps.size, "検出アプリケーションはありません。", "\n\n", limit_num)
      when "%APP_MATCH%" then
        match_all_apps = match_all_apps.uniq.sort
        opts[filtered_keyword] = filter_list_data.(type, data_num, match_all_apps, match_all_apps.size, "検出アプリケーションはありません。", "\n\n", limit_num)
      when "%PRODUCT_ALL%" then
        all_lapps = all_lapps.uniq.sort
        opts[filtered_keyword] = filter_list_data.(type, data_num, all_lapps, all_lapps.size, "手動登録プロダクトはありません。", ", ", limit_num)
      when "%PRODUCT_MATCH%" then
        match_all_lapps = match_all_lapps.uniq.sort
        opts[filtered_keyword] = filter_list_data.(type, data_num, match_all_lapps, match_all_lapps.size, "手動登録プロダクトはありません。", ", ", limit_num)
      when "%LPRODUCT_ALL%" then
        all_lproducts = all_lproducts.uniq.sort
        opts[filtered_keyword] = filter_list_data.(type, data_num, all_lproducts, all_lproducts.size, "ローカルプロダクトはありません。", ", ", limit_num)
      when "%LPRODUCT_MATCH%" then
        match_all_lproducts = match_all_lproducts.uniq.sort
        opts[filtered_keyword] = filter_list_data.(type, data_num, match_all_lproducts, match_all_lproducts.size, "ローカルプロダクトはありません。", ", ", limit_num)
      when "%VULSYNC_REGI_ALL%", "%VULSYNC_INFO_REGI_ALL%" then
        new_vuls = (keyword == "%VULSYNC_REGI_ALL%" ? self.create_vulsync_list(vulsync_content_add, setting_host_name, setting_protocol) : self.create_vulsync_info_list(vulsync_content_add, setting_host_name, setting_protocol, create_vul_info))
        opts[filtered_keyword] = filter_list_data.(type, data_num, new_vuls, new_vuls.size, "新たに登録された脆弱性はありません。", "\n\n", limit_num)
      when "%VULSYNC_RENEW_ALL%", "%VULSYNC_INFO_RENEW_ALL%" then
        mod_vuls = (keyword == "%VULSYNC_RENEW_ALL%" ? self.create_vulsync_list(vulsync_content_modify, setting_host_name, setting_protocol) : self.create_vulsync_info_list(vulsync_content_modify, setting_host_name, setting_protocol, create_vul_info))
        opts[filtered_keyword] = filter_list_data.(type, data_num, mod_vuls, mod_vuls.size, "更新された脆弱性はありません。", "\n\n", limit_num)
      when "%VULSYNC_DEL_ALL%", "%VULSYNC_INFO_DEL_ALL%" then
        del_vuls = (keyword == "%VULSYNC_DEL_ALL%" ? self.create_vulsync_list(vulsync_content_remove, setting_host_name, setting_protocol) : self.create_vulsync_info_list(vulsync_content_remove, setting_host_name, setting_protocol, create_vul_info))
        opts[filtered_keyword] = filter_list_data.(type, data_num, del_vuls, del_vuls.size, "削除(ステータスが「影響無」に変更)された脆弱性はありません。", "\n\n", limit_num)
      when "%VULSYNC_REGI_MATCH%", "%VULSYNC_INFO_REGI_MATCH%" then
        new_vuls = (keyword == "%VULSYNC_REGI_MATCH%" ? self.create_vulsync_list(filtered_vulsync_content_add, setting_host_name, setting_protocol) : self.create_vulsync_info_list(filtered_vulsync_content_add, setting_host_name, setting_protocol, create_vul_info))
        opts[filtered_keyword] = filter_list_data.(type, data_num, new_vuls, new_vuls.size, "新たに登録された脆弱性はありません。", "\n\n", limit_num)
      when "%VULSYNC_RENEW_MATCH%", "%VULSYNC_INFO_RENEW_MATCH%" then
        mod_vuls = (keyword == "%VULSYNC_RENEW_MATCH%" ? self.create_vulsync_list(filtered_vulsync_content_modify, setting_host_name, setting_protocol) : self.create_vulsync_info_list(filtered_vulsync_content_modify, setting_host_name, setting_protocol, create_vul_info))
        opts[filtered_keyword] = filter_list_data.(type, data_num, mod_vuls, mod_vuls.size, "更新された脆弱性はありません。", "\n\n", limit_num)
      when "%VULSYNC_DEL_MATCH%", "%VULSYNC_INFO_DEL_MATCH%" then
        del_vuls = (keyword == "%VULSYNC_DEL_MATCH%" ? self.create_vulsync_list(filtered_vulsync_content_remove, setting_host_name, setting_protocol) : self.create_vulsync_info_list(filtered_vulsync_content_remove, setting_host_name, setting_protocol, create_vul_info))
        opts[filtered_keyword] = filter_list_data.(type, data_num, del_vuls, del_vuls.size, "削除(ステータスが「影響無」に変更)された脆弱性はありません。", "\n\n", limit_num)
      when "%VULSYNC_REGI_HOST_ALL%", "%VULSYNC_REGI_HOST_MATCH%" then
        f_hostnames = self.create_vulsync_hostnames((keyword == "%VULSYNC_REGI_HOST_ALL%" ? vulsync_content_add : filtered_vulsync_content_add), 'hostname')
        opts[filtered_keyword] = filter_list_data.(type, data_num, f_hostnames, f_hostnames.size, "新たに登録された脆弱性のホストはありません。", ", ", limit_num)
      when "%VULSYNC_REGI_DISPLAY_NAME_ALL%", "%VULSYNC_REGI_DISPLAY_NAME_MATCH%" then
        f_display_names = self.create_vulsync_hostnames((keyword == "%VULSYNC_REGI_DISPLAY_NAME_ALL%" ? vulsync_content_add : filtered_vulsync_content_add), 'display_name')
        opts[filtered_keyword] = filter_list_data.(type, data_num, f_display_names, f_display_names.size, "新たに登録された脆弱性のホストはありません。", ", ", limit_num)
      when "%VULSYNC_RENEW_HOST_ALL%", "%VULSYNC_RENEW_HOST_MATCH%" then
        f_hostnames = self.create_vulsync_hostnames((keyword == "%VULSYNC_RENEW_HOST_ALL%" ? vulsync_content_modify : filtered_vulsync_content_modify), 'hostname') 
        opts[filtered_keyword] = filter_list_data.(type, data_num, f_hostnames, f_hostnames.size, "更新された脆弱性のホストはありません。", ", ", limit_num) 
      when "%VULSYNC_RENEW_DISPLAY_NAME_ALL%", "%VULSYNC_RENEW_DISPLAY_NAME_MATCH%" then
        f_display_names = self.create_vulsync_hostnames((keyword == "%VULSYNC_RENEW_DISPLAY_NAME_ALL%" ? vulsync_content_modify : filtered_vulsync_content_modify), 'display_name')
        opts[filtered_keyword] = filter_list_data.(type, data_num, f_display_names, f_display_names.size, "更新された脆弱性のホストはありません。", ", ", limit_num)
      when "%VULSYNC_DEL_HOST_ALL%", "%VULSYNC_DEL_HOST_MATCH%" then
        f_hostnames = self.create_vulsync_hostnames((keyword == "%VULSYNC_DEL_HOST_ALL%" ? vulsync_content_remove : filtered_vulsync_content_remove), 'hostname')
        opts[filtered_keyword] = filter_list_data.(type, data_num, f_hostnames, f_hostnames.size, "削除(ステータスが「影響無」に変更)された脆弱性のホストはありません。", ", ", limit_num)
      when "%VULSYNC_DEL_DISPLAY_NAME_ALL%", "%VULSYNC_DEL_DISPLAY_NAME_MATCH%" then
        f_display_names = self.create_vulsync_hostnames((keyword == "%VULSYNC_DEL_DISPLAY_NAME_ALL%" ? vulsync_content_remove : filtered_vulsync_content_remove), 'display_name')
        opts[filtered_keyword] = filter_list_data.(type, data_num, f_display_names, f_display_names.size, "削除(ステータスが「影響無」に変更)された脆弱性のホストはありません。", ", ", limit_num)
      when "%VULSYNC_ALL_HOST%", "%VULSYNC_ALL_DISPLAY_NAME%" then
        f_hostnames = self.create_vulsync_all_hostnames(data_for_keyword[:sync_hostids], (keyword == "%VULSYNC_ALL_HOST%" ? 'hostname' : 'display_name'))
        opts[filtered_keyword] = filter_list_data.(type, data_num, f_hostnames, f_hostnames.size, "同期対象となったホストはありません。", ", ", limit_num)
      when "%RULE_NAME%" then
        opts[filtered_keyword] = rule.name
      when "%RULE_CATEGORY%" then
        opts[filtered_keyword] = rule.sidfmd_category_id ? SidfmdCategory.find(rule.sidfmd_category_id).name : "全て"
      when "%RULE_TIMING%" then
        trigger = rule.sidfmd_rule_trigger.detail
        trigger_name = trigger.class.table_name
        case trigger_name
        when "sidfmd_rule_tp_hours" then
          opts[filtered_keyword] = "毎日実行-時間指定(実行時間: #{trigger.hour}時)"
        when "sidfmd_rule_tp_intervals"
          unit = trigger.unit
          unit = case unit 
                   when "hour" then "時間"
                   when "day" then "日"
                   when "week" then "週"
                   when "month" then "月"
                 end
          opts[filtered_keyword] =  "定期実行-間隔指定(実行間隔: #{trigger.value}#{unit}毎)"
        when "sidfmd_rule_t_vulsyncs" then
          opts[filtered_keyword] = "脆弱性同期時 実行(対象カテゴリ:#{trigger.sidfmd_category_id ? SidfmdCategory.find(rule.sidfmd_category_id).name : "全て"}" +
                                   " 対象ホスト:#{trigger.sidfmd_host_id ? SIdfmdHost.find(trigger.sidfmd_host_id).hostname : "全て"})"
        end
      when "%RULE_COND%" then
        items = []
        rule.sidfmd_rule_conds.each do |cond|
          cond = cond.detail  
          cond_name = cond.class.table_name
          if cond_name == "sidfmd_rule_c_issue_updates" then
            if cond.cond_or && cond.cnt_create > 0 then
              items << "脆弱性同期時(登録):脆弱性の登録が#{cond.cnt_create}件以上"
            elsif cond.cond_or && cond.cnt_remove > 0 then
              items << "脆弱性同期時(削除):脆弱性の削除が#{cond.cnt_remove}件以上" 
            elsif !cond.cond_or then
              items << "脆弱性同期時(登録&削除):脆弱性の登録が#{cond.cnt_create}件以上且つ脆弱性の削除が#{cond.cnt_remove}件以上"
            end
          elsif cond_name === "sidfmd_rule_c_cvss_exploitables" then
            items << "攻撃コード指定:#{cond.value ? "攻撃コードが有り" : "攻撃コードが無し"}#{cond.is_change ? "※攻撃コードの更新がある脆弱性のみが対象" : ""}"
          elsif cond_name == "sidfmd_rule_c_sri_aboves" then
            items << "SRI指定値以上:対象の脆弱性の危険度が#{SidfmdIssueSri::RISKS[cond.risk_id]}以上"
          elsif cond_name == "sidfmd_rule_c_sri_belows" then
            items << "SRI指定値以下:対象の脆弱性の危険度が#{SidfmdIssueSri::RISKS[cond.risk_id]}以下"
          elsif cond_name == "sidfmd_rule_c_cvss_aboves" then
            items << "CVSS指定値以上:対象の脆弱性の危険度が#{cond.cvss_value}以上" +
                     "(#{cond.is_notreg ?  "未定義の脆弱性を含める。" : "未定義の脆弱性を含めない。"}" +
                     if cond.exploitable.nil? then
                       "全ての脆弱性が対象。)"
                     elsif cond.exploitable == false then
                       "無しの脆弱性が対象。)"
                     else
                       "有りの脆弱性が対象。)"
                     end
          elsif cond_name == "sidfmd_rule_c_cvss_belows" then
            items << "CVSS指定値以下:対象の脆弱性の危険度が#{cond.cvss_value}以下" +
                     "(未定義を含めるかどうか:#{cond.is_notreg ? "未定義の脆弱性を含める" : "未定義の脆弱性を含めない"}" +
                     if cond.exploitable.nil? then
                       "全ての脆弱性が対象)"
                     elsif cond.exploitable == false then
                       "無しの脆弱性が対象)"
                     else
                       "有りの脆弱性が対象)"
                     end
          elsif cond_name == "sidfmd_rule_c_cvss_notregs" then
            items << "CVSS未定義:#{cond.is_notreg ? "未定義が対象" : "未定義以外が対象"}"
          elsif cond_name == "sidfmd_rule_c_warnings" then
            if cond.is_cvss then 
              items << "CVSS要注意:#{cond.is_warning ? "要注意が対象" : "要注意以外が対象"}" 
            else
              items << "SRI要注意:#{cond.is_warning ? "要注意が対象" : "要注意以外が対象"}"
            end
          elsif cond_name == "sidfmd_rule_c_history_posts" then
            items << "履歴追加:履歴の投稿が合計#{cond.cnt}件以上"
          elsif cond_name == "sidfmd_rule_c_duedate_expireds" then
            items << "対策予定日超過"
          elsif cond_name == "sidfmd_rule_c_duedate_approachings" then
            items << "対策予定日接近:対策予定日が#{cond.days}日後"
          elsif cond_name == "sidfmd_rule_c_match_categories" then
            sub_categories = cond.sidfmd_rule_cm_category_subs.map{|c| c.sidfmd_category_id}
            if cond.inv then
              item = "カスタムカテゴリ除外:#{SidfmdCategory.where(:id => sub_categories.slice(0..1)).map{|c|c.name}.join(", ")}"
            else
              item = "カスタムカテゴリ限定:#{SidfmdCategory.where(:id => sub_categories.slice(0..1)).map{|c|c.name}.join(", ")}"
            end
            item += " 他#{sub_categories.size - 2}カテゴリ" if sub_categories.size > 2
            items << item
          elsif cond_name == "sidfmd_rule_c_match_hosts" then
            hostids = cond.sidfmd_rule_cm_host_subs.map{|h| h.sidfmd_host_id}
            if cond.inv then
              item = "ホスト除外:#{SidfmdHost.where(:id => hostids.slice(0..1)).map{|h| h.hostname}.join(", ")}"
            else
              item = "ホスト限定:#{SidfmdHost.where(:id => hostids.slice(0..1)).map{|h| h.hostname}.join(", ")}"
            end
            item += " 他#{hostids.size - 2}ホスト" if hostids.size > 2
            items << item 
          elsif cond_name == "sidfmd_rule_c_statuses" then
            items << "ステータス一致:#{SidfmdIssue::STATUS_NAMES[cond.status_id1]}" +
                    (cond.status_id2 ? ",#{SidfmdIssue::STATUS_NAMES[cond.status_id2]}" : "") +
                    "が対象" 
          elsif cond_name == "sidfmd_rule_c_match_apps" then
            sub_apps = cond.sidfmd_rule_cm_app_subs
            prod_ids = []
            ver_ids = []
            sub_apps.each do |app|
              if !app.version_id then
                prod_ids.push(app.product_id)
              else
                ver_ids.push(app.version_id)
              end
            end
            p_names = []
            p_names.push(*SidfmdProduct.where(:id => prod_ids).map{|p| p.name})
            p_names.push(*SidfmdVersion.where(:id => ver_ids).map{|v| v.fullname})
            p_names = p_names.sort
            if cond.inv then
              item = "プロダクト不適合:#{p_names[0]}"
              item += ", #{p_names[1]}" if p_names[1]
            else
              item =  "プロダクト適合:#{p_names[0]}"
              item += ", #{p_names[1]}" if p_names[1]
            end
            item += " 他#{p_names.size - 2}プロダクト" if p_names.size > 2
            items << item
          end
        end
        opts[filtered_keyword] = items.sort.join(",\n")
      when "%RULE_ACTION%" then
        items = []
        #send_mail_user_ids = []
        #send_mail_user_emails = []
        #send_mail_user_sender_address = ""
        #send_mail_user_sender_userid = ""
        #send_mail_user_title = ""
        #send_mail_user_content = ""
        rule.sidfmd_rule_actions.each do |action|
          action = action.detail
          action_name = action.class.table_name
          if action_name == "sidfmd_rule_a_mail_categories" then
            items << "メール送信(カテゴリ)"
            #if action.from_user_id then
            #  sender = User.find(action.from_user_id)
            #  sender = "#{sender.lastname} #{sender.firstname}"
            #else
            #  sender = action.from_email
            #end
            #items << "メール送信(カテゴリ): 送信元:#{sender}, 送信先カテゴリ:#{action.sidfmd_category_id ? SidfmdCategory.find(action.sidfmd_category_id).name : "全体"}"
          elsif action_name == "sidfmd_rule_a_mail_users" then
            items << "メール送信(ユーザ)" unless items.include?("メール送信(ユーザ)")
            #if action.user_id then
            #  send_mail_user_ids.push(action.user_id)
            #else
            #  send_mail_user_emails.push(action.email)
            #end
            #if action.from_user_id then
            #  if send_mail_user_sender_userid == "" then
            #    send_mail_user_sender_userid = action.from_user_id
            #  end
            #else
            #  if send_mail_user_sender_address == "" then
            #    send_mail_user_sender_address = action.from_email
            #  end
            #end
            #if send_mail_user_title == "" then
            #  send_mail_user_title = action.subject
            #end
            #if send_mail_user_content == "" then
            #  send_mail_user_content = action.body
            #end
          elsif action_name == "sidfmd_rule_a_status_changes" then
            prev_statuses = "#{SidfmdIssue::STATUS_NAMES[action.prev_status1]}"
            prev_statuses += ",#{SidfmdIssue::STATUS_NAMES[action.prev_status2]}" if action.prev_status2
            items << "ステータス変更:#{prev_statuses}の場合 => " +
                     "#{SidfmdIssue::STATUS_NAMES[action.status_id]}に変更"
          elsif action_name == "sidfmd_rule_a_duedate_changes" then
            if action.fixed_date then
              items << "対策予定日設定:対策予定日を#{action.fixed_date.strftime("%Y/%m/%d")}に設定する" +
                       (action.permit_update ? "(上書き設定: 上書き)" : "(上書き設定: 上書きしない)")     
            else
              items << "対策予定日設定:対策予定日を#{action.refdt_days}日後に設定する" +
                       (action.permit_update ? "(上書き設定: 上書き)" : "(上書き設定: 上書きしない)")
            end
          end
        end
        #if send_mail_user_title != "" then
        #  if send_mail_user_ids.size > 0 then
        #    send_to = User.where(:id => send_mail_user_ids.slice(0..1)).map{|user| "#{user.lastname} #{user.firstname}"}.join(", ")
        #    send_to += " 他#{send_mail_user_ids.size - 2}ユーザ" if send_mail_user_ids.size > 2
        #  else
        #    send_to = send_mail_user_emails.slice(0..1).join(", ")
        #    send_to += " 他#{send_mail_user_emails.size - 2}件" if send_mail_user_emails.size > 2
        #  end
        #  if send_mail_user_sender_userid != "" then
        #    sender = User.find(send_mail_user_sender_userid)
        #    sender = "#{sender.lastname} #{sender.firstname}"
        #  else
        #    sender = send_mail_user_sender_address
        #  end
        #  items << "メール送信(ユーザ): 送信元:#{sender}, 送信先ユーザ:#{send_to}"
        #end
        opts[filtered_keyword] = items.sort.join(",\n")
      when "%RULE_DATE%" then
        opts[filtered_keyword] = Date.today.strftime("%Y年%m月%d日")
      end
    end
    return opts
  end  

end
