# -*- coding: utf-8 -*-

class ModifySidfmdRuleConds < ActiveRecord::Migration

  # PostgreSQLのテーブル名は63文字の制限があるため、一部省略していることに注意。

  def up
    # remove column: sidfmd_category_id, sidfmd_host_id
    remove_column :sidfmd_rule_c_history_posts, :sidfmd_host_id
    remove_column :sidfmd_rule_c_history_posts, :sidfmd_category_id
    remove_column :sidfmd_rule_c_duedate_expireds, :sidfmd_host_id
    remove_column :sidfmd_rule_c_duedate_expireds, :sidfmd_category_id
    remove_column :sidfmd_rule_c_duedate_approachings, :sidfmd_host_id
    remove_column :sidfmd_rule_c_duedate_approachings, :sidfmd_category_id
    remove_column :sidfmd_rule_c_match_categories, :sidfmd_category_id

    # カスタムカテゴリ適合のカテゴリ登録用サブテーブル
    create_table :sidfmd_rule_cm_category_subs do |t|
      t.references :sidfmd_rule_c_match_category, foreign_key: true, index: { name: :index_sidfmd_rule_cm_category_subs }, null: false

      # カスタムカテゴリ
      t.references :sidfmd_category, foreign_key: true, index: { name: :index_sidfmd_rule_cm_category_subs_c }, null: false
    end

    # ホスト適合
    create_table :sidfmd_rule_c_match_hosts do |t|
      t.references :sidfmd_rule_cond, foreign_key: true, index: true, null: false

      # false=指定したホストのみ true=指定したホスト以外
      t.boolean :inv, null: false, default: false
    end

    # ホスト適合のホスト登録用サブテーブル
    create_table :sidfmd_rule_cm_host_subs do |t|
      t.references :sidfmd_rule_c_match_host, foreign_key: true, index: true, null: false

      # ホスト
      t.references :sidfmd_host, foreign_key: true, index: { name: :index_sidfmd_rule_cm_host_sub_h }, null: false
    end
  end

  def down
    # add column: sidfmd_category_id, sidfmd_host_id
    add_column :sidfmd_rule_c_history_posts, :sidfmd_category_id, :integer
    add_column :sidfmd_rule_c_history_posts, :sidfmd_host_id, :integer
    add_column :sidfmd_rule_c_duedate_expireds, :sidfmd_category_id, :integer
    add_column :sidfmd_rule_c_duedate_expireds, :sidfmd_host_id, :integer
    add_column :sidfmd_rule_c_duedate_approachings, :sidfmd_category_id, :integer
    add_column :sidfmd_rule_c_duedate_approachings, :sidfmd_host_id, :integer
    add_column :sidfmd_rule_c_match_categories, :sidfmd_category_id, :integer

    # remove tables
    drop_table :sidfmd_rule_cm_category_subs
    drop_table :sidfmd_rule_cm_host_subs
    drop_table :sidfmd_rule_c_match_hosts
  end

end
