#!/usr/bin/env ruby
# -*- coding: utf-8 -*-

class AddExtName < ActiveRecord::Migration
  IDX_NAME = 'sidfmd_hosts_name_idx'

  def up
    add_column :sidfmd_hosts, :ext_name, :string, index: true
    ActiveRecord::Base.connection.execute("CREATE INDEX #{IDX_NAME} ON sidfmd_hosts (COALESCE(ext_name,hostname,''))")
  end

  def down
    ActiveRecord::Base.connection.execute("DROP INDEX #{IDX_NAME}")
    remove_column :sidfmd_hosts, :ext_name
  end
end
