# -*- coding: utf-8 -*-

Dir[File.expand_path('../lib/sidfm', __FILE__) << '/*.rb'].each do |file|
  require_dependency file
end

if Rack::Utils.respond_to?(:'key_space_limit=') then
  Rack::Utils.key_space_limit = 262144
end

Redmine::Plugin.register :sidfm do
  name 'SIDfm VM'
  author 'SofTek Systems, Inc.'
  description 'SIDfm VM - Vulneraiblities Manager'
  version File.open('/sidfmvm-version').read.chomp
  url 'https://sid-fm.com/'
  author_url 'https://sid-fm.com/'

  project_module :sidfm do
    # 閲覧権限
    permission :view_sidfm, :sidfm => [ :index ]
    # 利用権限
    permission :use_sidfm, :sidfm => [ :index ]
    # 管理権限
    permission :admin_sidfm, :sidfm => [ :index ]

    # ユーザ管理権限(他ユーザの管理権限)
    # 1. ユーザ設定で他ユーザの閲覧が可能
    # 2. ユーザ設定で他ユーザの設定変更が可能
    # 3. ログイン名の変更が可能
    # 注意：この権限を持たないユーザは、他ユーザの閲覧は不可
    permission :user_admin_sidfm, :sidfm => [ :index ]

    # ホスト管理権限
    # 自分の管理対象範囲で、全てのホストの全ての操作が可能
    permission :host_admin_sidfm, :sidfm => [ :index ]

    # ホスト管理特定権限
    # 自分の管理対象範囲で、プロダクト変更とメモ変更のみ可能
    permission :host_limited_admin_sidfm, :sidfm => [ :index ]

    # ルール管理権限
    # ルールの設定を行う機能
    permission :rule_admin_sidfm, :sidfm => [ :index ]

  end

  menu :top_menu, :sidfm_top, { :controller => :sidfm, :action => :index }, :caption => 'SIDfm'

end
