# -*- coding: utf-8 -*-
require 'json'
require 'uri'
require 'net/http'

# modify me

url = 'http://localhost/redmine/sidfm/api/'
apikey = ''

########### 
$url_parsed = URI.parse(url)
api = Net::HTTP.new($url_parsed.host, $url_parsed.port)

def path(method, params = {}) 
  ret = $url_parsed.path + method
  if params.size > 0 then
    ret += '?'
    ret += URI.encode_www_form(params)
    #ret += concat_params(params)
  end
  puts "path: #{ret}"
  ret
end

def show_res(res)
  p res
  p JSON.parse(res.body) if res.body
end

# (ブラウザで確認できる)サマリー表の内容と一致しているかの確認のために使用
def show_names(res, target)
  body = JSON.parse(res.body || '{}')
  content = body[target]
  if content then
    p content.map{|data|
      case target
      when 'users' then
        data['login']
      when 'hosts' then
        data['display_name']
      when 'vulnerabilities' then
        data['html_id']
      when 'journals' then
        data['created_on']
      else
        ''
      end
    }
  end
end

# *** API Test ****

# modify me

existing_auth_name = ''
not_existing_auth_name = 'xxx'

existing_category_name = 'サンプルA'
not_existing_category_name = 'xxx'
custom_category_id = 16

existing_cat_group_id = 117
not_existing_cat_group_id = 1

product_name = 'Microsoft Windows'
version_name = 'Microsoft Windows Server 2019'
lproduct_name = ''
lversion_name = ''

osname = 'CentOS 7'

sidfmd_host_id = ''

filter_journal_sidfmd_host_id = ''

ctag_names = ['タグA', 'sample1']

html_id = 36994

login = ''

username = ''

email_address = ''

hostname = ''

displayname = ''

###########
puts '*** index ***'
res = api.get(path('index'))
show_res(res)

puts '*** auth ***'
puts 'case 1(get:no auth) : must be false'
res = api.get(path('auth'))
show_res(res)
puts 'case 2(get:auth param) : must be true'
res = api.get(path('auth', { 'q[api_key]' => apikey }))
show_res(res)
puts 'case 3(get:auth header) : must be true'
res = api.get(path('auth'), { 'X-API-Key' => apikey })
show_res(res)
puts 'case 4(post:no auth) : must be false'
res = api.post(path('auth'), '')
show_res(res)
puts 'case 5(post:auth get param) : must be true'
res = api.post(path('auth', { 'q[api_key]' => apikey }), '')
show_res(res)
puts 'case 6(post:auth post param) : must be true'
res = api.post(path('auth'), URI.encode_www_form({ 'q[api_key]' => apikey }))
show_res(res)
puts 'case 7(post:auth header) : must be true'
res = api.post(path('auth'), '', { 'X-API-Key' => apikey })
show_res(res)

puts '*** version ***'
res = api.get(path('version'), { 'X-API-Key' => apikey })
show_res(res)

puts '*** categories ***'
res = api.get(path('categories'), { 'X-API-Key' => apikey })
show_res(res)
res = api.get(path('categories', { 'q[offset]' => 1, 'q[per_page]' => 1 } ), { 'X-API-Key' => apikey })
show_res(res)
res = api.get(path('categories', { 'q[filters][name]' => '業務' } ), { 'X-API-Key' => apikey })
show_res(res)
res = api.get(path('categories', { 'q[filters][name][]' => [ '業', '務' ] } ), { 'X-API-Key' => apikey })
show_res(res)
res = api.get(path('categories', { 'q[filters][id]' => 23 } ), { 'X-API-Key' => apikey })
show_res(res)
res = api.get(path('categories', { 'q[filters][id][]' => [ 1, 23 ] } ), { 'X-API-Key' => apikey })
show_res(res)
res = api.get(path('categories', { 'q[filters][is_system]' => true } ), { 'X-API-Key' => apikey })
show_res(res)
res = api.get(path('categories', { 'q[filters][is_system]' => true, 'q[filters][id]' => 3 } ), { 'X-API-Key' => apikey })
show_res(res)

puts '*** users ***'
res = api.get(path('users'), { 'X-API-Key' => apikey })
show_names(res, 'users')
show_res(res)
res = api.get(path('users', { 'q[offset]' => 1, 'q[per_page]' => 1 } ), { 'X-API-Key' => apikey })
show_names(res, 'users')
show_res(res)
# filters #
res = api.get(path('users', { 'q[filters][login]' => 'test' } ), { 'X-API-Key' => apikey })
show_names(res, 'users')
show_res(res)
res = api.get(path('users', { 'q[filters][name]' => 'test' } ), { 'X-API-Key' => apikey })
show_names(res, 'users')
show_res(res)
res = api.get(path('users', { 'q[filters][auth]' => 'password' } ), { 'X-API-Key' => apikey })
show_names(res, 'users')
show_res(res)
res = api.get(path('users', { 'q[filters][auth]' => 'openidconnect' } ), { 'X-API-Key' => apikey })
show_names(res, 'users')
show_res(res)
res = api.get(path('users', { 'q[filters][auth]' => existing_auth_name } ), { 'X-API-Key' => apikey })
show_names(res, 'users')
show_res(res)
res = api.get(path('users', { 'q[filters][auth]' => not_existing_auth_name } ), { 'X-API-Key' => apikey })
show_names(res, 'users')
show_res(res)
res = api.get(path('users', { 'q[filters][role]' => 'SIDfmVM報告者' } ), { 'X-API-Key' => apikey })
show_names(res, 'users')
show_res(res)
res = api.get(path('users', { 'q[filters][role]' => 'SIDfmVM不正利用者' } ), { 'X-API-Key' => apikey })
show_names(res, 'users')
show_res(res)
res = api.get(path('users', { 'q[filters][category]' => existing_category_name } ), { 'X-API-Key' => apikey })
show_names(res, 'users')
show_res(res)
res = api.get(path('users', { 'q[filters][category]' => not_existing_category_name } ), { 'X-API-Key' => apikey })
show_names(res, 'users')
show_res(res)
res = api.get(path('users', { 'q[filters][category_group][id]' => existing_cat_group_id } ), { 'X-API-Key' => apikey })
show_names(res, 'users')
show_res(res)
res = api.get(path('users', { 'q[filters][category_group][id]' => not_existing_cat_group_id } ), { 'X-API-Key' => apikey })
show_names(res, 'users')
show_res(res)
res = api.get(path('users', { 'q[filters][category_group][no_group]' => true } ), { 'X-API-Key' => apikey })
show_names(res, 'users')
show_res(res)
res = api.get(path('users', { 'q[filters][email_enable]' => true } ), { 'X-API-Key' => apikey })
show_names(res, 'users')
show_res(res)
res = api.get(path('users', { 'q[filters][email_enable]' => false } ), { 'X-API-Key' => apikey })
show_names(res, 'users')
show_res(res)
res = api.get(path('users', { 'q[filters][lock_enable]' => true } ), { 'X-API-Key' => apikey })
show_names(res, 'users')
show_res(res)
res = api.get(path('users', { 'q[filters][lock_enable]' => false } ), { 'X-API-Key' => apikey })
show_names(res, 'users')
show_res(res)
res = api.get(path('users', { 'q[filters][login_date_begin]' => '2022/10/01' } ), { 'X-API-Key' => apikey })
show_names(res, 'users')
show_res(res)
res = api.get(path('users', { 'q[filters][login_date_end]' => '2022/03/01' } ), { 'X-API-Key' => apikey })
show_names(res, 'users')
show_res(res)
res = api.get(path('users', { 'q[filters][login_date_nologin]' => true } ), { 'X-API-Key' => apikey })
show_names(res, 'users')
show_res(res)
res = api.get(
  path(
    'users',
    { 'q[filters][login_date_end]' => '2022/10/01', 'q[filters][login_date_begin]' => '2022/03/01' }
  ),
  { 'X-API-Key' => apikey }
)
show_names(res, 'users')
show_res(res)
res = api.get(path('users', { 'q[filters][role]' => 'SIDfmVM報告者', 'q[filters][category]' => existing_category_name } ), { 'X-API-Key' => apikey })
show_names(res, 'users')
show_res(res)
# sort #
res = api.get(path('users', { 'q[order]' => 'login_asc' } ), { 'X-API-Key' => apikey })
show_names(res, 'users')
show_res(res)
res = api.get(path('users', { 'q[order]' => 'login_desc' } ), { 'X-API-Key' => apikey })
show_names(res, 'users')
show_res(res)
res = api.get(path('users', { 'q[order]' => 'lastname_asc' } ), { 'X-API-Key' => apikey })
show_names(res, 'users')
show_res(res)
res = api.get(path('users', { 'q[order]' => 'lastname_desc' } ), { 'X-API-Key' => apikey })
show_names(res, 'users')
show_res(res)
res = api.get(path('users', { 'q[order]' => 'auth_asc' } ), { 'X-API-Key' => apikey })
show_names(res, 'users')
show_res(res)
res = api.get(path('users', { 'q[order]' => 'auth_desc' } ), { 'X-API-Key' => apikey })
show_names(res, 'users')
show_res(res)
res = api.get(path('users', { 'q[order]' => 'mail_notification_asc' } ), { 'X-API-Key' => apikey })
show_names(res, 'users')
show_res(res)
res = api.get(path('users', { 'q[order]' => 'mail_notification_desc' } ), { 'X-API-Key' => apikey })
show_names(res, 'users')
show_res(res)
res = api.get(path('users', { 'q[order]' => 'lock_asc' } ), { 'X-API-Key' => apikey })
show_names(res, 'users')
show_res(res)
res = api.get(path('users', { 'q[order]' => 'lock_desc' } ), { 'X-API-Key' => apikey })
show_names(res, 'users')
show_res(res)
res = api.get(path('users', { 'q[order]' => 'last_login_on_asc' } ), { 'X-API-Key' => apikey })
show_names(res, 'users')
show_res(res)
res = api.get(path('users', { 'q[order]' => 'last_login_on_desc' } ), { 'X-API-Key' => apikey })
show_names(res, 'users')
show_res(res)
# sort and filters #
res = api.get(path('users', { 'q[order]' => 'lastname_desc', 'q[filters][lock_enable]' => false, 'q[filters][role]' => 'SIDfmVM報告者' } ), { 'X-API-Key' => apikey })
show_names(res, 'users')
show_res(res)
puts '*** hosts ***'
res = api.get(path('hosts'), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts', { 'q[offset]' => 1, 'q[per_page]' => 1 } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
# filters #
res = api.get(path('hosts', { 'q[filters][warning]' => 'warning' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts', { 'q[filters][warning]' => 'others' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts', { 'q[filters][products][product_all_version_names][]' => [product_name] } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts', { 'q[filters][products][product_names][]' => [product_name] } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts', { 'q[filters][products][version_names][]' => [version_name] } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts', { 'q[filters][products][lproduct_all_version_names][]' => [lproduct_name] } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts', { 'q[filters][products][lproduct_names][]' => [lproduct_name] } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts', { 'q[filters][products][lversion_names][]' => [lversion_name] } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts', { 'q[filters][products][product_names][]' => [product_name], 'q[filters][products][lversion_names][]' => [lversion_name] } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)

res = api.get(path('hosts', { 'q[filters][status]' => '未対策' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts', { 'q[filters][status][]' => ['対策済', '影響無'] } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)

res = api.get(path('hosts', { 'q[filters][sris][]' => ['無', '高'] } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts', { 'q[filters][cvsses][]' => ['notreg', 'd1'] } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts', { 'q[filters][area]' => 'ローカル' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts', { 'q[filters][exploitable]' => true } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts', { 'q[filters][categories][names][]' => [existing_category_name] } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts', { 'q[filters][categories][ids][]' => [custom_category_id] } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(
  path(
    'hosts',
     {
      'q[filters][categories][ids][]' => [1, custom_category_id],
      'q[filters][categories][is_and]' => true, 
     }
   ),
   { 'X-API-Key' => apikey }
)
show_names(res, 'hosts')
show_res(res)
res = api.get(
  path(
    'hosts',
     {
      'q[filters][categories][names][]' => [existing_category_name, 'サンプルB'],
      'q[filters][categories][is_except]' => true,
     }
   ),
   { 'X-API-Key' => apikey }
)
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts', { 'q[filters][os]' => osname } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts', { 'q[filters][date_begin]' => '2022/06/01' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts', { 'q[filters][date_end]' => '2020/06/01' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts', { 'q[filters][date_begin]' => '2022/06/01', 'q[filters][date_end]' => '2022/08/31' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts', { 'q[filters][date_begin]' => '2022/06/01', 'q[filters][date_outside_period]' => true } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts', { 'q[filters][date_end]' => '2020/06/01', 'q[filters][date_outside_period]' => true } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts', { 'q[filters][date_begin]' => '2022/06/01', 'q[filters][date_end]' => '2022/08/31', 'q[filters][date_outside_period]' => true } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts', { 'q[filters][due_date_begin]' => '2022/06/01' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts', { 'q[filters][due_date_end]' => '2020/06/01' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts', { 'q[filters][due_date_begin]' => '2022/06/01', 'q[filters][due_date_end]' => '2022/08/31' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts', { 'q[filters][due_date_nodate]' => true } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts', { 'q[filters][keyword]' => 'test' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts', { 'q[filters][keyword]' => 'test', 'q[filters][status]' => '未対策' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
# sort #
res = api.get(path('hosts', { 'q[order]' => 'warning_asc' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts', { 'q[order]' => 'warning_desc' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts', { 'q[order]' => 'statuses_asc' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts', { 'q[order]' => 'statuses_desc' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts', { 'q[order]' => 'maxsri_asc' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts', { 'q[order]' => 'maxsri_desc' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts', { 'q[order]' => 'maxcvss_asc' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts', { 'q[order]' => 'maxcvss_desc' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts', { 'q[order]' => 'area_asc' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts', { 'q[order]' => 'area_desc' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts', { 'q[order]' => 'exploitable_asc' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts', { 'q[order]' => 'exploitable_desc' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts', { 'q[order]' => 'hostname_asc' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts', { 'q[order]' => 'hostname_desc' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts', { 'q[order]' => 'categories_asc' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts', { 'q[order]' => 'categories_desc' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts', { 'q[order]' => 'os_asc' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts', { 'q[order]' => 'os_desc' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts', { 'q[order]' => 'duedates_asc' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts', { 'q[order]' => 'duedates_desc' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts', { 'q[order]' => 'finished_asc' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts', { 'q[order]' => 'finished_desc' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
# sort and filters #
res = api.get(path('hosts', { 'q[order]' => 'warning_asc', 'q[filters][status][]' => ['未対策', '対策中'] } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
# index #
res = api.get(path('hosts', { 'q[order]' => 'warning_asc', 'q[filters][warning]' => 'others', 'q[index]' => 'cvss' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts', { 'q[order]' => 'warning_asc', 'q[filters][warning]' => 'others', 'q[index]' => 'sri' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
# category #
res = api.get(path('hosts', { 'q[category]' => existing_category_name } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
# prior_category #
res = api.get(path('hosts', { 'q[prior_category]' => 'custom' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts', { 'q[prior_category]' => 'system' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts', { 'q[prior_category]' => 'custom', 'q[order]' => 'categories_desc' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
# all #
res = api.get(
  path(
    'hosts', 
    {
      'q[order]' => 'warning_asc',
      'q[filters][warning]' => 'warning',
      'q[index]' => 'cvss',
      'q[category]' => existing_category_name,
      'q[prior_category]' => 'custom'
    }
  ),
  { 'X-API-Key' => apikey }
)
show_names(res, 'hosts')
show_res(res)

puts '*** vulnerabilities_by_host ***'

res = api.get(path('vulnerabilities_by_host', { 'q[host_id]' => sidfmd_host_id }), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities_by_host', { 'q[host_id]' => sidfmd_host_id, 'q[offset]' => 1, 'q[per_page]' => 1 } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
# filters #
res = api.get(path('vulnerabilities_by_host', { 'q[host_id]' => sidfmd_host_id, 'q[filters][products][product_names][]' => [product_name] } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities_by_host', { 'q[host_id]' => sidfmd_host_id, 'q[filters][products][version_names][]' => [version_name] } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities_by_host', { 'q[host_id]' => sidfmd_host_id, 'q[filters][products][lproduct_names][]' => [lproduct_name] } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities_by_host', { 'q[host_id]' => sidfmd_host_id, 'q[filters][products][lversion_names][]' => [lversion_name] } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities_by_host', { 'q[host_id]' => sidfmd_host_id, 'q[filters][products][version_names][]' => [version_name], 'q[filters][products][lproduct_names][]' => [lproduct_name] } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)

res = api.get(path('vulnerabilities_by_host', { 'q[host_id]' => filter_journal_sidfmd_host_id, 'q[filters][journal_date_begin]' => '2022/06/01' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities_by_host', { 'q[host_id]' => filter_journal_sidfmd_host_id, 'q[filters][journal_date_begin]' => '2022/06/01', 'q[filters][journal_outside_period]' => true } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities_by_host', { 'q[host_id]' => filter_journal_sidfmd_host_id, 'q[filters][journal_date_begin]' => '2022/06/01', 'q[filters][journal_date_end]' => '2022/07/01', 'q[filters][journal_status_change]' => true, 'q[filters][journal_outside_period]' => true } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities_by_host', { 'q[host_id]' => filter_journal_sidfmd_host_id, 'q[filters][journal_date_begin]' => '2022/03/01', 'q[filters][journal_date_end]' => '2022/07/01', 'q[filters][journal_duedate_change]' => true } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities_by_host', { 'q[host_id]' => filter_journal_sidfmd_host_id, 'q[filters][journal_date_begin]' => '2022/06/01', 'q[filters][journal_duedate_change]' => true, 'q[filters][journal_status_change]' => true, 'q[filters][journal_outside_period]' => true } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities_by_host', { 'q[host_id]' => sidfmd_host_id, 'q[filters][warning]' => 'warning' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities_by_host', { 'q[host_id]' => sidfmd_host_id, 'q[filters][warning]' => 'others' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities_by_host', { 'q[host_id]' => sidfmd_host_id, 'q[filters][status][]' => ['未対策', '対策中'] } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities_by_host', { 'q[host_id]' => sidfmd_host_id, 'q[filters][status]' => '対策済' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities_by_host', { 'q[host_id]' => sidfmd_host_id, 'q[filters][sris][]' => ['中', '高'] } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities_by_host', { 'q[host_id]' => sidfmd_host_id, 'q[filters][cvsses][]' => ['d2', 'd3' ] } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities_by_host', { 'q[host_id]' => sidfmd_host_id, 'q[filters][cvss_vector][cvss_v2][AV]' => 'N' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities_by_host', { 'q[host_id]' => sidfmd_host_id, 'q[filters][cvss_vector][cvss_v3][AV]' => 'N' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities_by_host', { 'q[host_id]' => sidfmd_host_id, 'q[filters][cvss_vector][is_target_unregistered]' => true } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities_by_host', { 'q[host_id]' => sidfmd_host_id, 'q[filters][area]' => 'クライアント' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities_by_host', { 'q[host_id]' => sidfmd_host_id, 'q[filters][exploitable]' => true } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities_by_host', { 'q[host_id]' => sidfmd_host_id, 'q[filters][due_date_begin]' => '2022/06/01' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities_by_host', { 'q[host_id]' => sidfmd_host_id, 'q[filters][due_date_end]' => '2020/06/01' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities_by_host', { 'q[host_id]' => sidfmd_host_id, 'q[filters][due_date_begin]' => '2022/06/01', 'q[filters][due_date_end]' => '2022/08/31' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities_by_host', { 'q[host_id]' => sidfmd_host_id, 'q[filters][due_date_nodate]' => true } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities_by_host', { 'q[host_id]' => sidfmd_host_id, 'q[filters][date_begin]' => '2022/07/01' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities_by_host', { 'q[host_id]' => sidfmd_host_id, 'q[filters][date_end]' => '2022/07/01', 'q[filters][date_target]' => 'detected_date' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities_by_host', { 'q[host_id]' => sidfmd_host_id, 'q[filters][date_begin]' => '2022/01/01', 'q[filters][date_outside_period]' => true, 'q[filters][date_target]' => 'created_date' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities_by_host', { 'q[host_id]' => sidfmd_host_id, 'q[filters][date_begin]' => '2022/01/01', 'q[filters][date_outside_period]' => true, 'q[filters][date_end]' => '2022/06/01', 'q[filters][date_target]' => 'created_date' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities_by_host', { 'q[host_id]' => sidfmd_host_id, 'q[filters][date_begin]' => '2022/01/01', 'q[filters][date_end]' => '2022/02/01', 'q[filters][date_target]' => 'updated_date' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities_by_host', { 'q[host_id]' => sidfmd_host_id, 'q[filters][ctags][]' => ctag_names } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities_by_host', { 'q[host_id]' => sidfmd_host_id, 'q[filters][keyword]' => '38605' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities_by_host', { 'q[filters][warning]' => 'warning', 'q[host_id]' => sidfmd_host_id, 'q[filters][status][]' => ['未対策','対策中'] } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
# sort #
res = api.get(path('vulnerabilities_by_host', { 'q[host_id]' => sidfmd_host_id, 'q[order]' => 'warning_asc' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities_by_host', { 'q[host_id]' => sidfmd_host_id, 'q[order]' => 'warning_desc' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities_by_host', { 'q[host_id]' => sidfmd_host_id, 'q[order]' => 'status_asc' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities_by_host', { 'q[host_id]' => sidfmd_host_id, 'q[order]' => 'status_desc' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities_by_host', { 'q[host_id]' => sidfmd_host_id, 'q[order]' => 'sri_asc' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities_by_host', { 'q[host_id]' => sidfmd_host_id, 'q[order]' => 'sri_desc' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities_by_host', { 'q[host_id]' => sidfmd_host_id, 'q[order]' => 'cvss_asc' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities_by_host', { 'q[host_id]' => sidfmd_host_id, 'q[order]' => 'cvss_desc' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities_by_host', { 'q[host_id]' => sidfmd_host_id, 'q[order]' => 'area_asc' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities_by_host', { 'q[host_id]' => sidfmd_host_id, 'q[order]' => 'area_desc' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities_by_host', { 'q[host_id]' => sidfmd_host_id, 'q[order]' => 'exploitable_asc' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities_by_host', { 'q[host_id]' => sidfmd_host_id, 'q[order]' => 'exploitable_desc' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities_by_host', { 'q[host_id]' => sidfmd_host_id, 'q[order]' => 'elapseddays_asc' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities_by_host', { 'q[host_id]' => sidfmd_host_id, 'q[order]' => 'elapseddays_desc' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities_by_host', { 'q[host_id]' => sidfmd_host_id, 'q[order]' => 'title_asc' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities_by_host', { 'q[host_id]' => sidfmd_host_id, 'q[order]' => 'title_desc' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities_by_host', { 'q[host_id]' => sidfmd_host_id, 'q[order]' => 'journals_asc' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities_by_host', { 'q[host_id]' => sidfmd_host_id, 'q[order]' => 'journals_desc' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities_by_host', { 'q[host_id]' => sidfmd_host_id, 'q[order]' => 'duedate_asc' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities_by_host', { 'q[host_id]' => sidfmd_host_id, 'q[order]' => 'duedate_desc' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
# index #
res = api.get(path('vulnerabilities_by_host', { 'q[index]' => 'cvss', 'q[host_id]' => sidfmd_host_id, 'q[order]' => 'warning_asc' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities_by_host', { 'q[index]' => 'sri', 'q[host_id]' => sidfmd_host_id, 'q[order]' => 'warning_asc' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)

# all #
res = api.get(
  path(
    'vulnerabilities_by_host', 
    {
      'q[order]' => 'warning_asc',
      'q[filters][warning]' => 'warning',
      'q[index]' => 'cvss',
      'q[host_id]' => sidfmd_host_id
    }
  ),
  { 'X-API-Key' => apikey }
)
show_names(res, 'vulnerabilities')
show_res(res)

puts '*** vulnerabilities ***'
res = api.get(path('vulnerabilities'), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities', { 'q[offset]' => 1, 'q[per_page]' => 1 } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
# filters #
res = api.get(path('vulnerabilities', { 'q[filters][warning]' => 'warning' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities', { 'q[filters][warning]' => 'others' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities', { 'q[filters][products][product_names][]' => [product_name] } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities', { 'q[filters][products][version_names][]' => [version_name] } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities', { 'q[filters][products][lproduct_names][]' => [lproduct_name] } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities', { 'q[filters][products][lversion_names][]' => [lversion_name] } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities', { 'q[filters][products][product_names][]' => [product_name], 'q[filters][products][lversion_names][]' => [lversion_name] } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities', { 'q[filters][status]' => '対策済' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities', { 'q[filters][status][]' => ['未対策', '対策中'] } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)

res = api.get(path('vulnerabilities', { 'q[filters][sris][]' => ['無', '高'] } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities', { 'q[filters][cvsses][]' => ['notreg', 'd1'] } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities', { 'q[filters][area]' => 'ローカル' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities', { 'q[filters][exploitable]' => true } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities', { 'q[filters][cvss_vector][cvss_v2][AV]' => 'N' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities', { 'q[filters][cvss_vector][cvss_v3][AV]' => 'N' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(
  path(
    'vulnerabilities',
    {
      'q[filters][cvss_vector][cvss_v2][AV]' => 'A',
      'q[filters][cvss_vector][cvss_v2][AC]' => 'M',
      'q[filters][cvss_vector][cvss_v3][AV]' => 'A',
      'q[filters][cvss_vector][cvss_v3][AC]' => 'L'
    }
  ),
  { 'X-API-Key' => apikey }
)
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities', { 'q[filters][cvss_vector][is_target_unregistered]' => true } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities', { 'q[filters][categories][names][]' => [existing_category_name] } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities', { 'q[filters][categories][ids][]' => [custom_category_id] } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(
  path(
    'vulnerabilities',
     {
      'q[filters][categories][ids][]' => [1, custom_category_id],
      'q[filters][categories][is_and]' => true, 
     }
   ),
   { 'X-API-Key' => apikey }
)
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(
  path(
    'vulnerabilities',
     {
      'q[filters][categories][names][]' => [existing_category_name, 'サンプルB'],
      'q[filters][categories][is_except]' => true,
     }
   ),
   { 'X-API-Key' => apikey }
)
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities', { 'q[filters][due_date_begin]' => '2022/06/01' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities', { 'q[filters][due_date_end]' => '2020/06/01' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities', { 'q[filters][due_date_begin]' => '2022/06/01', 'q[filters][due_date_end]' => '2022/08/31' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities', { 'q[filters][due_date_nodate]' => true } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities', { 'q[filters][date_begin]' => '2022/07/01', 'q[filters][date_target]' => 'detected_date' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities', { 'q[filters][date_end]' => '2022/07/01', 'q[filters][date_target]' => 'created_date' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities', { 'q[filters][date_begin]' => '2022/01/01', 'q[filters][date_outside_period]' => true, 'q[filters][date_target]' => 'created_date' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities', { 'q[filters][date_begin]' => '2022/01/01', 'q[filters][date_outside_period]' => true, 'q[filters][date_end]' => '2022/06/01', 'q[filters][date_target]' => 'updated_date' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities', { 'q[filters][date_begin]' => '2022/01/01', 'q[filters][date_end]' => '2022/02/01', 'q[filters][date_target]' => 'updated_date' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)

res = api.get(path('vulnerabilities', { 'q[filters][keyword]' => 'docker' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities', { 'q[filters][ctags][]' => ctag_names } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
# sort #
res = api.get(path('vulnerabilities', { 'q[order]' => 'warning_asc' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities', { 'q[order]' => 'warning_desc' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities', { 'q[order]' => 'statuses_asc' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities', { 'q[order]' => 'statuses_desc' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities', { 'q[order]' => 'maxsri_asc' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities', { 'q[order]' => 'maxsri_desc' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities', { 'q[order]' => 'maxcvss_asc' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities', { 'q[order]' => 'maxcvss_desc' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities', { 'q[order]' => 'area_asc' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities', { 'q[order]' => 'area_desc' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities', { 'q[order]' => 'exploitable_asc' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities', { 'q[order]' => 'exploitable_desc' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities', { 'q[order]' => 'elapseddays_asc' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities', { 'q[order]' => 'elapseddays_desc' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities', { 'q[order]' => 'title_asc' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities', { 'q[order]' => 'title_desc' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities', { 'q[order]' => 'hostnames_asc' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities', { 'q[order]' => 'hostnames_desc' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities', { 'q[order]' => 'categories_asc' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities', { 'q[order]' => 'categories_desc' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities', { 'q[order]' => 'duedates_asc' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities', { 'q[order]' => 'duedates_desc' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities', { 'q[order]' => 'finished_asc' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities', { 'q[order]' => 'finished_desc' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
# index #
res = api.get(path('vulnerabilities', { 'q[order]' => 'warning_asc', 'q[filters][warning]' => 'others', 'q[index]' => 'cvss' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities', { 'q[order]' => 'warning_asc', 'q[filters][warning]' => 'others', 'q[index]' => 'sri' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
# category #
res = api.get(path('vulnerabilities', { 'q[category]' => existing_category_name } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
# prior_category #
res = api.get(path('vulnerabilities', { 'q[prior_category]' => 'custom' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities', { 'q[prior_category]' => 'system' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
res = api.get(path('vulnerabilities', { 'q[prior_category]' => 'custom', 'q[order]' => 'categories_desc' } ), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)
# all #
res = api.get(
  path(
    'vulnerabilities', 
    {
      'q[order]' => 'warning_asc',
      'q[filters][warning]' => 'warning',
      'q[index]' => 'cvss',
      'q[category]' => existing_category_name,
      'q[prior_category]' => 'custom'
    }
  ),
  { 'X-API-Key' => apikey }
)
show_names(res, 'vulnerabilities')
show_res(res)

puts '*** hosts_by_vulnerability ***'
res = api.get(path('hosts_by_vulnerability', { 'q[html_id]' => html_id } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts_by_vulnerability', { 'q[html_id]' => html_id, 'q[offset]' => 1, 'q[per_page]' => 1 } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
# filters #
res = api.get(path('hosts_by_vulnerability', { 'q[html_id]' => html_id, 'q[filters][warning]' => 'warning' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts_by_vulnerability', { 'q[html_id]' => html_id, 'q[filters][warning]' => 'others' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts_by_vulnerability', { 'q[html_id]' => html_id, 'q[filters][products][product_all_version_names][]' => [product_name] } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts_by_vulnerability', { 'q[html_id]' => html_id, 'q[filters][products][product_names][]' => [product_name] } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts_by_vulnerability', { 'q[html_id]' => html_id, 'q[filters][products][version_names][]' => [version_name] } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts_by_vulnerability', { 'q[html_id]' => html_id, 'q[filters][products][lproduct_all_version_names][]' => [lproduct_name] } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts_by_vulnerability', { 'q[html_id]' => html_id, 'q[filters][products][lproduct_names][]' => [lproduct_name] } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts_by_vulnerability', { 'q[html_id]' => html_id, 'q[filters][products][lversion_names][]' => [lversion_name] } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts_by_vulnerability', { 'q[html_id]' => html_id, 'q[filters][products][product_names][]' => [product_name], 'q[filters][products][lversion_names][]' => [lversion_name] } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)

res = api.get(path('hosts_by_vulnerability', { 'q[html_id]' => html_id, 'q[filters][status]' => '未対策' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts_by_vulnerability', { 'q[html_id]' => html_id, 'q[filters][status][]' => ['対策済','影響無'] } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)

res = api.get(path('hosts_by_vulnerability', { 'q[html_id]' => html_id, 'q[filters][sris][]' => ['無', '高'] } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts_by_vulnerability', { 'q[html_id]' => html_id, 'q[filters][cvsses][]' => ['notreg', 'd3'] } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts_by_vulnerability', { 'q[html_id]' => html_id, 'q[filters][exploitable]' => true } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts_by_vulnerability', { 'q[html_id]' => html_id, 'q[filters][categories][names][]' => [existing_category_name] } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts_by_vulnerability', { 'q[html_id]' => html_id, 'q[filters][categories][ids][]' => [custom_category_id] } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(
  path(
    'hosts_by_vulnerability',
     {
       'q[html_id]' => html_id, 
      'q[filters][categories][ids][]' => [1, custom_category_id],
      'q[filters][categories][is_and]' => true, 
     }
   ),
   { 'X-API-Key' => apikey }
)
show_names(res, 'hosts')
show_res(res)
res = api.get(
  path(
    'hosts_by_vulnerability',
     {
      'q[html_id]' => html_id, 
      'q[filters][categories][names][]' => [existing_category_name, 'サンプルB', '公開サーバ'],
      'q[filters][categories][is_except]' => true,
     }
   ),
   { 'X-API-Key' => apikey }
)
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts_by_vulnerability', { 'q[html_id]' => html_id, 'q[filters][os]' => osname } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts_by_vulnerability', { 'q[html_id]' => html_id, 'q[filters][journal_date_begin]' => '2022/06/01' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts_by_vulnerability', { 'q[html_id]' => html_id, 'q[filters][journal_date_begin]' => '2022/06/01' , 'q[filters][journal_outside_period]' => true } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts_by_vulnerability', { 'q[html_id]' => html_id, 'q[filters][journal_date_end]' => '2022/06/01', 'q[filters][journal_status_change]' => true } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts_by_vulnerability', { 'q[html_id]' => html_id, 'q[filters][journal_date_begin]' => '2022/06/01', 'q[filters][journal_date_end]' => '2022/07/01', 'q[filters][journal_duedate_change]' => true } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts_by_vulnerability', { 'q[html_id]' => html_id, 'q[filters][journal_date_end]' => '2022/06/01', 'q[filters][journal_duedate_change]' => true, 'q[filters][journal_status_change]' => true } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts_by_vulnerability', { 'q[html_id]' => html_id, 'q[filters][date_begin]' => '2022/06/01' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts_by_vulnerability', { 'q[html_id]' => html_id, 'q[filters][date_end]' => '2020/06/01' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts_by_vulnerability', { 'q[html_id]' => html_id, 'q[filters][date_begin]' => '2022/06/01', 'q[filters][date_end]' => '2022/08/31' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts_by_vulnerability', { 'q[html_id]' => html_id, 'q[filters][date_begin]' => '2022/06/01', 'q[filters][date_outside_period]' => true } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts_by_vulnerability', { 'q[html_id]' => html_id, 'q[filters][date_end]' => '2020/06/01', 'q[filters][date_outside_period]' => true } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts_by_vulnerability', { 'q[html_id]' => html_id, 'q[filters][date_begin]' => '2022/06/01', 'q[filters][date_end]' => '2022/08/31', 'q[filters][date_outside_period]' => true } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts_by_vulnerability', { 'q[html_id]' => html_id, 'q[filters][due_date_begin]' => '2022/06/01' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts_by_vulnerability', { 'q[html_id]' => html_id, 'q[filters][due_date_end]' => '2021/11/18' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts_by_vulnerability', { 'q[html_id]' => html_id, 'q[filters][due_date_begin]' => '2022/06/01', 'q[filters][due_date_end]' => '2022/08/31' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts_by_vulnerability', { 'q[html_id]' => html_id, 'q[filters][due_date_nodate]' => true } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts_by_vulnerability', { 'q[html_id]' => html_id, 'q[filters][keyword]' => 'test' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts_by_vulnerability', { 'q[html_id]' => html_id, 'q[filters][keyword]' => 'test', 'q[filters][status]' => '未対策' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts_by_vulnerability', { 'q[html_id]' => html_id, 'q[filters][ctags][]' => ctag_names } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
# sort #
res = api.get(path('hosts_by_vulnerability', { 'q[html_id]' => html_id, 'q[order]' => 'warning_asc' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts_by_vulnerability', { 'q[html_id]' => html_id, 'q[order]' => 'warning_desc' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts_by_vulnerability', { 'q[html_id]' => html_id, 'q[order]' => 'status_asc' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts_by_vulnerability', { 'q[html_id]' => html_id, 'q[order]' => 'status_desc' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts_by_vulnerability', { 'q[html_id]' => html_id, 'q[order]' => 'sri_asc' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts_by_vulnerability', { 'q[html_id]' => html_id, 'q[order]' => 'sri_desc' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts_by_vulnerability', { 'q[html_id]' => html_id, 'q[order]' => 'cvss_asc' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts_by_vulnerability', { 'q[html_id]' => html_id, 'q[order]' => 'cvss_desc' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts_by_vulnerability', { 'q[html_id]' => html_id, 'q[order]' => 'exploitable_asc' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts_by_vulnerability', { 'q[html_id]' => html_id, 'q[order]' => 'exploitable_desc' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts_by_vulnerability', { 'q[html_id]' => html_id, 'q[order]' => 'elapseddays_asc' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts_by_vulnerability', { 'q[html_id]' => html_id, 'q[order]' => 'elapseddays_desc' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts_by_vulnerability', { 'q[html_id]' => html_id, 'q[order]' => 'hostname_asc' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts_by_vulnerability', { 'q[html_id]' => html_id, 'q[order]' => 'hostname_desc' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts_by_vulnerability', { 'q[html_id]' => html_id, 'q[order]' => 'categories_asc' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts_by_vulnerability', { 'q[html_id]' => html_id, 'q[order]' => 'categories_desc' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts_by_vulnerability', { 'q[html_id]' => html_id, 'q[order]' => 'os_asc' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts_by_vulnerability', { 'q[html_id]' => html_id, 'q[order]' => 'os_desc' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts_by_vulnerability', { 'q[html_id]' => html_id, 'q[order]' => 'journals_asc' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts_by_vulnerability', { 'q[html_id]' => html_id, 'q[order]' => 'journals_desc' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts_by_vulnerability', { 'q[html_id]' => html_id, 'q[order]' => 'duedate_asc' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts_by_vulnerability', { 'q[html_id]' => html_id, 'q[order]' => 'duedate_desc' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
# sort and filters #
res = api.get(path('hosts_by_vulnerability', { 'q[html_id]' => html_id, 'q[order]' => 'warning_asc', 'q[filters][status][]' => ['未対策', '対策中'] } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
# index #
res = api.get(path('hosts_by_vulnerability', { 'q[html_id]' => html_id, 'q[order]' => 'warning_asc', 'q[filters][warning]' => 'others', 'q[index]' => 'cvss' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts_by_vulnerability', { 'q[html_id]' => html_id, 'q[order]' => 'warning_asc', 'q[filters][warning]' => 'others', 'q[index]' => 'sri' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
# category #
res = api.get(path('hosts_by_vulnerability', { 'q[html_id]' => html_id, 'q[category]' => '内部サーバ' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
# prior_category #
res = api.get(path('hosts_by_vulnerability', { 'q[html_id]' => html_id, 'q[prior_category]' => 'custom' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts_by_vulnerability', { 'q[html_id]' => html_id, 'q[prior_category]' => 'system' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
res = api.get(path('hosts_by_vulnerability', { 'q[html_id]' => html_id, 'q[prior_category]' => 'custom', 'q[order]' => 'categories_desc' } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)
# all #
res = api.get(
  path(
    'hosts_by_vulnerability', 
    {
      'q[html_id]' => html_id,
      'q[order]' => 'warning_asc',
      'q[filters][warning]' => 'warning',
      'q[index]' => 'cvss',
      'q[category]' => existing_category_name,
      'q[prior_category]' => 'custom'
    }
  ),
  { 'X-API-Key' => apikey }
)
show_names(res, 'hosts')
show_res(res)
puts '*** journals ***'
res = api.get(path('journals'), { 'X-API-Key' => apikey })
show_names(res, 'journals')
show_res(res)
res = api.get(path('journals', { 'q[offset]' => 1, 'q[per_page]' => 1 } ), { 'X-API-Key' => apikey })
show_names(res, 'journals')
show_res(res)
# filters #
res = api.get(path('journals', { 'q[filters][roles][names][]' => [ 'SIDfmVM報告者', 'SIDfmVM利用者' ] }), { 'X-API-Key' => apikey })
show_names(res, 'journals')
show_res(res)
res = api.get(path('journals', { 'q[filters][roles][names][]' => [ 'SIDfmVM報告者', 'SIDfmVM利用者' ], 'q[filters][roles][is_except]' => true }), { 'X-API-Key' => apikey })
show_names(res, 'journals')
show_res(res)
res = api.get(path('journals', { 'q[filters][users][logins][]' => [ login ] }), { 'X-API-Key' => apikey })
show_names(res, 'journals')
show_res(res)
res = api.get(path('journals', { 'q[filters][users][logins][]' => [ login ], 'q[filters][users][is_except]' => true }), { 'X-API-Key' => apikey })
show_names(res, 'journals')
show_res(res)
res = api.get(path('journals', { 'q[filters][users][is_except_anonymous]' => true }), { 'X-API-Key' => apikey })
show_names(res, 'journals')
show_res(res)
res = api.get(path('journals', { 'q[filters][users][mail_addresses][]' => [ email_address ] }), { 'X-API-Key' => apikey })
show_names(res, 'journals')
show_res(res)
res = api.get(path('journals', { 'q[filters][users][names][]' => [ username ] }), { 'X-API-Key' => apikey })
show_names(res, 'journals')
show_res(res)
res = api.get(
  path(
    'journals',
    {
      'q[filters][users][is_except_anonymous]' => true,
      'q[filters][users][logins][]' => [ login, 'testuser' ], 
      'q[filters][roles][names][]' => [ 'SIDfmVM報告者', 'SIDfmVM利用者' ],
      'q[filters][users][is_except]' => true,
      'q[filters][users][mail_addresses][]' => [ email_address ] 
    }
  ), { 'X-API-Key' => apikey })
show_names(res, 'journals')
show_res(res)
res = api.get(path('journals', { 'q[filters][hosts][hostnames][]' => [ hostname ] }), { 'X-API-Key' => apikey })
show_names(res, 'journals')
show_res(res)
res = api.get(path('journals', { 'q[filters][hosts][display_names][]' => [ displayname ] }), { 'X-API-Key' => apikey })
show_names(res, 'journals')
show_res(res)
res = api.get(
  path(
    'journals',
    {
      'q[filters][hosts][hostnames][]' => [ hostname ],
      'q[filters][hosts][display_names][]' => [ displayname ],
      'q[filters][hosts][is_except]' => true
    }
  ),
  { 'X-API-Key' => apikey }
)
show_names(res, 'journals')
show_res(res)
res = api.get(path('journals', { 'q[filters][categories][names][]' => [ existing_category_name ] }), { 'X-API-Key' => apikey })
show_names(res, 'journals')
show_res(res)
res = api.get(path('journals', { 'q[filters][categories][ids][]' => [custom_category_id] }), { 'X-API-Key' => apikey })
show_names(res, 'journals')
show_res(res)
res = api.get(path('journals', { 'q[filters][categories][names][]' => [ existing_category_name ], 'q[filters][categories][is_except]' => true }), { 'X-API-Key' => apikey })
show_names(res, 'journals')
show_res(res)
res = api.get(path('journals', { 'q[filters][categories][names][]' => [ existing_category_name, '内部サーバ' ], 'q[filters][categories][is_and]' => true }), { 'X-API-Key' => apikey })
show_names(res, 'journals')
show_res(res)
res = api.get(path('journals', { 'q[filters][date_begin]' => '2022/06/01' } ), { 'X-API-Key' => apikey })
show_names(res, 'journals')
show_res(res)
res = api.get(path('journals', { 'q[filters][date_end]' => '2020/06/01' } ), { 'X-API-Key' => apikey })
show_names(res, 'journals')
show_res(res)
res = api.get(path('journals', { 'q[filters][date_begin]' => '2022/06/01', 'q[filters][date_end]' => '2022/08/31' } ), { 'X-API-Key' => apikey })
show_names(res, 'journals')
show_res(res)
res = api.get(path('journals', { 'q[filters][date_begin]' => '2022/06/01', 'q[filters][date_outside_period]' => true } ), { 'X-API-Key' => apikey })
show_names(res, 'journals')
show_res(res)
res = api.get(path('journals', { 'q[filters][date_end]' => '2020/06/01', 'q[filters][date_outside_period]' => true } ), { 'X-API-Key' => apikey })
show_names(res, 'journals')
show_res(res)
res = api.get(path('journals', { 'q[filters][date_begin]' => '2022/06/01', 'q[filters][date_end]' => '2022/08/31', 'q[filters][date_outside_period]' => true } ), { 'X-API-Key' => apikey })
show_names(res, 'journals')
show_res(res)
res = api.get(path('journals', { 'q[filters][operations][items][]' =>  ['ステータス変更'] } ), { 'X-API-Key' => apikey })
show_names(res, 'journals')
show_res(res)
res = api.get(path('journals', { 'q[filters][operations][items][]' =>  ['対策予定日変更'] } ), { 'X-API-Key' => apikey })
show_names(res, 'journals')
show_res(res)
res = api.get(path('journals', { 'q[filters][operations][items][]' =>  ['ステータス変更', '対策予定日変更'], 'q[filters][operations][is_except]' => true } ), { 'X-API-Key' => apikey })
show_names(res, 'journals')
show_res(res)
res = api.get(path('journals', { 'q[filters][status]' => '対策済' } ), { 'X-API-Key' => apikey })
show_names(res, 'journals')
show_res(res)
res = api.get(path('journals', { 'q[filters][status][]' => ['未対策', '対策中'] } ), { 'X-API-Key' => apikey })
show_names(res, 'journals')
show_res(res)
res = api.get(path('journals', { 'q[filters][comment][text]' => 'test' } ), { 'X-API-Key' => apikey })
show_names(res, 'journals')
show_res(res)
res = api.get(path('journals', { 'q[filters][comment][text]' => '変更', 'q[filters][comment][is_except]' => true } ), { 'X-API-Key' => apikey })
show_names(res, 'journals')
show_res(res)
res = api.get(path('journals', { 'q[filters][vulnerabilities]' => html_id.to_s } ), { 'X-API-Key' => apikey })
show_names(res, 'journals')
show_res(res)
res = api.get(path('journals', { 'q[filters][ctags][]' => ctag_names } ), { 'X-API-Key' => apikey })
show_names(res, 'journals')
show_res(res)
# sort
res = api.get(path('journals', { 'q[order]' => 'created_on_asc' } ), { 'X-API-Key' => apikey })
show_names(res, 'journals')
show_res(res)
res = api.get(path('journals', { 'q[order]' => 'created_on_desc' } ), { 'X-API-Key' => apikey })
show_names(res, 'journals')
show_res(res)
res = api.get(path('journals', { 'q[order]' => 'login_name_asc' } ), { 'X-API-Key' => apikey })
show_names(res, 'journals')
show_res(res)
res = api.get(path('journals', { 'q[order]' => 'login_name_desc' } ), { 'X-API-Key' => apikey })
show_names(res, 'journals')
show_res(res)
res = api.get(path('journals', { 'q[order]' => 'operation_asc' } ), { 'X-API-Key' => apikey })
show_names(res, 'journals')
show_res(res)
res = api.get(path('journals', { 'q[order]' => 'operation_desc' } ), { 'X-API-Key' => apikey })
show_names(res, 'journals')
show_res(res)
res = api.get(path('journals', { 'q[order]' => 'hostname_asc' } ), { 'X-API-Key' => apikey })
show_names(res, 'journals')
show_res(res)
res = api.get(path('journals', { 'q[order]' => 'hostname_desc' } ), { 'X-API-Key' => apikey })
show_names(res, 'journals')
show_res(res)
res = api.get(path('journals', { 'q[order]' => 'vul_title_asc' } ), { 'X-API-Key' => apikey })
show_names(res, 'journals')
show_res(res)
res = api.get(path('journals', { 'q[order]' => 'vul_title_desc' } ), { 'X-API-Key' => apikey })
show_names(res, 'journals')
show_res(res)
res = api.get(path('journals', { 'q[order]' => 'status_asc' } ), { 'X-API-Key' => apikey })
show_names(res, 'journals')
show_res(res)
res = api.get(path('journals', { 'q[order]' => 'status_desc' } ), { 'X-API-Key' => apikey })
show_names(res, 'journals')
show_res(res)
res = api.get(path('journals', { 'q[order]' => 'due_date_asc' } ), { 'X-API-Key' => apikey })
show_names(res, 'journals')
show_res(res)
res = api.get(path('journals', { 'q[order]' => 'due_date_desc' } ), { 'X-API-Key' => apikey })
show_names(res, 'journals')
show_res(res)
# sort and filters
res = api.get(path('journals', { 'q[filters][categories][names][]' => [ existing_category_name, '内部サーバ' ], 'q[order]' => 'due_date_desc' } ), { 'X-API-Key' => apikey })
show_names(res, 'journals')
show_res(res)

puts '*** must fail in hosts_by_vulnerability ***'
res = api.get(path('hosts_by_vulnerability', { 'q[html_id]' => 11 } ), { 'X-API-Key' => apikey })
show_names(res, 'hosts')
show_res(res)

# test by not admin user without categories.
#res = api.get(path('hosts_by_vulnerability', { 'q[html_id]' => html_id } ), { 'X-API-Key' => apikey })
#show_names(res, 'hosts')
#show_res(res)

puts '*** vulnerabilities_by_host ***'

puts '*** must fail in vulnerabilities_by_host ***'
res = api.get(path('vulnerabilities_by_host', { 'q[host_id]' => 5000 }), { 'X-API-Key' => apikey })
show_names(res, 'vulnerabilities')
show_res(res)

# test by not admin user without categories.
#res = api.get(path('vulnerabilities_by_host', { 'q[host_id]' => sidfmd_host_id }), { 'X-API-Key' => apikey })
#show_names(res, 'vulnerabilities')
#show_res(res)
